/**
 * Created with JetBrains WebStorm.
 * User: BJOLLING
 * Date: 18/08/12
 * Time: 17:28
 * Released under the GNU General Public License version 3
 */
 
 loader.addFinishHandler(function() {

qx.Class.define("lou_extensions_ui.ListScriptView",
    {
        extend:qx.ui.window.Window,

        construct:function () {
            this.base(arguments, "Available Scripts");

            this.setShowMinimize(false);
            this.setWidth(400);
            this.setContentPadding(5);

            var layout = new qx.ui.layout.VBox();
            layout.setSpacing(4);
            this.setLayout(layout);

            // list of installed extensions
            var optionString = localStorage.getItem("lou-extensions-options");
            this.options = qx.lang.Json.parse(optionString);

            var grpBox = new qx.ui.groupbox.GroupBox;
            this.add(grpBox, {row: 1, column: 0});

            grpBox.setLayout(new qx.ui.layout.VBox());

            // add scripts and checkboxes to group box
            for (var key in this.options.scripts) {
                var script = this.options.scripts[key];
                var newCheck = new qx.ui.form.CheckBox(script.name)
                newCheck.setValue(script.enabled);
                newCheck.setUserData("key", key);
                newCheck.set({
                    toolTipText : script.description
                });

                newCheck.addListener("changeValue", function(e) {
                    var key = e.getTarget().getUserData("key");
                    var script = this.options.scripts[key];
                    script.enabled = e.getData();
                }, this);
                grpBox.add(newCheck);
            }

            grpBox.setLegend("Scripts included in lou-extensions v." + this.options.version);

            var restartLabel = new qx.ui.basic.Label("You need to restart LoU for the changes to take effect.");
            this.add(restartLabel);

            // Toolbar action buttons
            var toolbar = new qx.ui.container.Composite();
            var fl = new qx.ui.layout.Flow(5,5);
            fl.setAlignX( "right" );
            toolbar.setLayout(fl);
            this.add(toolbar);

            //Save Changes button
            var saveChangesButton = new qx.ui.form.Button("Save and Close");
            saveChangesButton.setToolTipText("Save changes in configuration to local browser settings");
            saveChangesButton.addListener("execute", function() {
                this._saveChanges();
            }, this);
            toolbar.add(saveChangesButton);
        },

        // --------------------------------------------------------------------------
        // [Properties]
        // --------------------------------------------------------------------------
        properties : {
            options : { nullable : true }
        },

        // --------------------------------------------------------------------------
        // [Members]
        // --------------------------------------------------------------------------
        members : {
            _saveChanges : function() {
                if(this.options) {
                    var optionString = qx.lang.Json.stringify(this.options);
                    localStorage.setItem("lou-extensions-options", optionString);
                };
                this.close();
            }
        }
    }
);
});