/**
 * Created with JetBrains WebStorm.
 * User: BJOLLING
 * Date: 12/08/12
 * Time: 20:55
 * Released under the GNU General Public License version 3
 */

loader.addFinishHandler(function() {

    qx.Class.define("lou_extensions_ui.main", {
        type : "singleton",
        extend : qx.core.Object,
        members : {
            app: null,
            menuContainer: null,
            listScriptView: null,
            initialize : function () {
                try {
                    // button to manage scripts //
                    var extensionsButton = new webfrontend.ui.SoundButton("Extensions");
                    extensionsButton.set({
                        appearance: "button-text-small",
                        toolTipText: "Open lou-extensions",
                        decorator: "button-bar"
                    });
                    extensionsButton.addListener("click", this.showManageScriptView, this);

                    var numberOfMenuItems = this.menuContainer.getChildren().length - 1;
                    var endImage = this.menuContainer.getLayout().getCellWidget(0, numberOfMenuItems);
                    this.menuContainer.remove(endImage);
                    this.menuContainer.add(extensionsButton,{ row: 0, column: numberOfMenuItems})
                    this.menuContainer.add(endImage,{ row: 0, column: numberOfMenuItems +1})

                } catch (e) {
                    console.log("[lou_extensions] ERROR lou_extensions_ui.main.initialize: " + e);
                }
            },
            showManageScriptView : function () {
                if(!(this.listScriptView)) {
                    this.listScriptView = new lou_extensions_ui.ListScriptView();
                    this.listScriptView.addListener("resize", this.listScriptView.center);
                };
                this.listScriptView.show();
                this.listScriptView.setActive(true);
            }
        },
        construct : function() {
            this.app = qx.core.Init.getApplication();
            this.menuContainer = this.app.title.reportButton.getLayoutParent();
        }
    });

    function InitializeLouExtensionsUI(){
        var app = qx.core.Init.getApplication();
        if( app && app.title && app.title.reportButton ) {
            console.log("[lou_extensions] InitializeLouExtensionsUI");
            lou_extensions_ui.main.getInstance().initialize();
        } else {
            console.log("[lou_extensions] Retrying InitializeLouExtensionsUI");
            window.setTimeout(InitializeLouExtensionsUI, 1000);
        }
    }

    //Initialize UI components of lou_extensions;
    InitializeLouExtensionsUI();

});
