/// Dynamic script loader for lou-extensions in Google Chrome.
"use strict";
/**
 * Dynamic injection of javascript and css files based on the list
 * of 'web_accessible_resources' in the manifest.json file
 * @namespace lou_extensions
 * @version 0.7.0
 */

/**
 * Main function
 */
try {
    console.log('[lou-extensions] Loading LOU extensions');

    if (chrome != undefined && chrome.extension != undefined) {
        var url = chrome.extension.getURL('manifest.json');

        // load extensions manifest.json file
        var xhr = new XMLHttpRequest();
        xhr.open("GET", url, false);
        xhr.send();
        var manifest = JSON.parse(xhr.responseText);

        lou_extensions.loadExtensions(manifest);

    } else {
        console.log('[lou-extensions] Chrome extensions not available. No lou-extensions were injected');
    }
} catch (e) {
    console.log('[lou-extensions]' + e);
}

