// ==UserScript==
// @name        lou-extensions
// @namespace   https://github.com/ConanLoxley/lou-extensions
// @description Collection of extensions for Lord of Ultima (http://www.lordofultima.com/)
// @include     http://prodgame*.lordofultima.com/*
// @downloadURL https://userscripts.org/scripts/source/138566.user.js
// @updateURL   https://userscripts.org/scripts/source/138566.meta.js
// @version     0.7.2
// @run-at      document-end
// @grant       GM_info
// @grant       GM_getResourceText
// @grant       GM_getResourceURL
// @icon        http://conanloxley.github.com/lou-extensions/release/icons/icon48.png
// @require     extensions/options.js
// @require     extensions/inject.js
// @resource    extensions/ui_ListScriptView                    extensions/ui/ListScriptView.js
// @resource    extensions/ui_main                              extensions/ui/main.js
// @resource    extensions/sprintf                              extensions/sprintf.min.js
// @resource    compat/qooxdoo                                  compat/compat_qooxdoo.js
// @resource    compat/lou                                      compat/compat_lou.js
// @resource    louBos/const                                    louBos/bos_const.js
// @resource    louBos/LocalizedStrings                         louBos/bos_LocalizedStrings.js
// @resource    louBos/gui_SummaryPage                          louBos/bos_gui_SummaryPage.js
// @resource    louBos/gui_ResourcesFillerWidget                louBos/bos_gui_ResourcesFillerWidget.js
// @resource    louBos/BatchResourcesFiller                     louBos/bos_BatchResourcesFiller.js
// @resource    louBos/ResourcesFiller                          louBos/bos_ResourcesFiller.js
// @resource    louBos/Server                                   louBos/bos_Server.js
// @resource    louBos/Storage                                  louBos/bos_Storage.js
// @resource    louBos/net_CommandManager                       louBos/bos_net_CommandManager.js
// @resource    louBos/Tweaks                                   louBos/bos_Tweaks.js
// @resource    louBos/Main                                     louBos/bos_Main.js
// @resource    louBos/SharestringConverter                     louBos/bos_SharestringConverter.js
// @resource    louBos/Utils                                    louBos/bos_Utils.js
// @resource    louBos/CityTypes                                louBos/bos_CityTypes.js
// @resource    louBos/City                                     louBos/bos_City.js
// @resource    louBos/gui_TradeOrdersPage                      louBos/bos_gui_TradeOrdersPage.js
// @resource    louBos/gui_TradeRouteWidget                     louBos/bos_gui_TradeRouteWidget.js
// @resource    louBos/gui_PurifyOptionsWidget                  louBos/bos_gui_PurifyOptionsWidget.js
// @resource    louBos/gui_PurifyResourcesPage                  louBos/bos_gui_PurifyResourcesPage.js
// @resource    louBos/gui_TradeRoutesPage                      louBos/bos_gui_TradeRoutesPage.js
// @resource    louBos/gui_MyAlliancePage                       louBos/bos_gui_MyAlliancePage.js
// @resource    louBos/gui_IntelligenceOptionsWidget            louBos/bos_gui_IntelligenceOptionsWidget.js
// @resource    louBos/gui_IntelligencePage                     louBos/bos_gui_IntelligencePage.js
// @resource    louBos/gui_PlayerInfoPage                       louBos/bos_gui_PlayerInfoPage.js
// @resource    louBos/gui_AllianceInfoPage                     louBos/bos_gui_AllianceInfoPage.js
// @resource    louBos/gui_IncomingAttacksPage                  louBos/bos_gui_IncomingAttacksPage.js
// @resource    louBos/gui_MassRecruitmentOptionsWidget         louBos/bos_gui_MassRecruitmentOptionsWidget.js
// @resource    louBos/gui_MassRecruitmentPage                  louBos/bos_gui_MassRecruitmentPage.js
// @resource    louBos/gui_UnitOrdersPage                       louBos/bos_gui_UnitOrdersPage.js
// @resource    louBos/gui_RegionPage                           louBos/bos_gui_RegionPage.js
// @resource    louBos/gui_DungeonsPage                         louBos/bos_gui_DungeonsPage.js
// @resource    louBos/gui_CastlesPage                          louBos/bos_gui_CastlesPage.js
// @resource    louBos/gui_CitiesPage                           louBos/bos_gui_CitiesPage.js
// @resource    louBos/gui_OptionsPage                          louBos/bos_gui_OptionsPage.js
// @resource    louBos/gui_MilitaryPage                         louBos/bos_gui_MilitaryPage.js
// @resource    louBos/gui_DefendersPage                        louBos/bos_gui_DefendersPage.js
// @resource    louBos/gui_ExtraSummaryWidget                   louBos/bos_gui_ExtraSummaryWidget.js
// @resource    louBos/gui_SummaryWidget                        louBos/bos_gui_SummaryWidget.js
// @resource    louBos/gui_FoodCalculatorWidget                 louBos/bos_gui_FoodCalculatorWidget.js
// @resource    louBos/gui_RecruitmentSpeedCalculatorWidget     louBos/bos_gui_RecruitmentSpeedCalculatorWidget.js
// @resource    louBos/gui_CombatCalculatorWidget               louBos/bos_gui_CombatCalculatorWidget.js
// @resource    louBos/ui_table_cellrenderer_Default            louBos/bos_ui_table_cellrenderer_Default.js
// @resource    louBos/ui_table_cellrenderer_HumanTime          louBos/bos_ui_table_cellrenderer_HumanTime.js
// @resource    louBos/ui_table_cellrenderer_ClickableLook      louBos/bos_ui_table_cellrenderer_ClickableLook.js
// @resource    louBos/ui_table_cellrenderer_Resource           louBos/bos_ui_table_cellrenderer_Resource.js
// @resource    louBos/ui_table_cellrenderer_FullAt             louBos/bos_ui_table_cellrenderer_FullAt.js
// @resource    louBos/ui_table_Table                           louBos/bos_ui_table_Table.js
// @resource    louTweak/globals                                louTweak/louTweak_globals.js
// @resource    louTweak/localizedStrings                       louTweak/louTweak_localizedStrings.js
// @resource    louTweak/main                                   louTweak/louTweak_main.js
// @resource    louTweak/queueTimesLabel                        louTweak/louTweak_queueTimesLabel.js
// @resource    louTweak/incomingResourcesLabel                 louTweak/louTweak_incomingResourcesLabel.js
// @resource    louTweak/optionsPage                            louTweak/louTweak_optionsPage.js
// @resource    louTweak/overlayObject                          louTweak/louTweak_overlayObject.js
// @resource    louTweak/layoutWindow                           louTweak/louTweak_layoutWindow.js
// @resource    louTweak/miniMap                                louTweak/louTweak_miniMap.js
// @resource    louTweak/checkIfLoaded                          louTweak/louTweak_checkIfLoaded.js
// @resource    louMerc3/paTweak3_pakMap                        louMerc3/paTweak3_pakMap.js
// @resource    louMerc3/paTweak3_Version                       louMerc3/paTweak3_Version.js
// @resource    louMerc3/paTweak3_Main                          louMerc3/paTweak3_Main.js
// @resource    louMerc3/paTweak3_utils                         louMerc3/paTweak3_utils.js
// @resource    louMerc3/paTweak3_ui_IncomingAttacksWindow      louMerc3/paTweak3_ui_IncomingAttacksWindow.js
// @resource    louMerc3/paTweak3_ui_RaidReporter               louMerc3/paTweak3_ui_RaidReporter.js
// @resource    louMerc3/paTweak3_ui_RaidingWindow              louMerc3/paTweak3_ui_RaidingWindow.js
// @resource    louMerc3/paTweak3_ui_PalaceItemsWindow          louMerc3/paTweak3_ui_PalaceItemsWindow.js
// @resource    louMerc3/paTweak3_ui_AllianceMailingListWindows louMerc3/paTweak3_ui_AllianceMailingListWindow.js
// @resource    louMerc3/paTweak3_ui_ReturnByWindow             louMerc3/paTweak3_ui_ReturnByWindow.js
// @resource    louMerc3/paTweak3_ui_PlayerReportsWindow        louMerc3/paTweak3_ui_PlayerReportsWindow.js
// @resource    louMerc3/paTweak3_CombatTools                   louMerc3/paTweak3_CombatTools.js
// @resource    louMerc3/paTweak3_CoordUtils                    louMerc3/paTweak3_CoordUtils.js
// @resource    louMerc3/paTweak3_BossUtils                     louMerc3/paTweak3_BossUtils.js
// @resource    louMerc3/paTweak3_ui_components_AttackOrder     louMerc3/paTweak3_ui_components_AttackOrder.js
// @resource    louMerc3/paTweak3_ui_components_LeftPanel       louMerc3/paTweak3_ui_components_LeftPanel.js
// @resource    louMerc3/paTweak3_ui_components_TimePicker      louMerc3/paTweak3_ui_components_TimePicker.js
// @resource    louMerc3/paTweak3_ui_AboutWindow                louMerc3/paTweak3_ui_AboutWindow.js
// @resource    louMerc3/paTweak3_ui_CancelOrderPanel           louMerc3/paTweak3_ui_CancelOrderPanel.js
// @resource    louMerc3/paTweak3_ui_CombatWindow               louMerc3/paTweak3_ui_CombatWindow.js
// @resource    louMerc3/paTweak3_ui_CombatWindowExport         louMerc3/paTweak3_ui_CombatWindowExport.js
// @resource    louMerc3/paTweak3_ui_IdleRaidUnitsTable         louMerc3/paTweak3_ui_IdleRaidUnitsTable.js
// @resource    louMerc3/paTweak3_ui_ExtraTools                 louMerc3/paTweak3_ui_ExtraTools.js
// @resource    louMerc3/paTweak3_checkIfLoaded                 louMerc3/paTweak3_checkIfLoaded.js
// ==/UserScript==

/**
 * Main function
 */
"use strict";

var theWindow = (typeof(unsafeWindow) == "undefined") ? window : unsafeWindow;
theWindow.lou_extensions = theWindow.lou_extensions || {};

(function (lou_extensions) {
    try {
        console.log("[lou-extensions] Loading LoU extensions.");

        var info = getScriptMetaData();

        lou_extensions.version = info.script.version;

        if (info.script && info.script.resources2) {
            loadExtensions(info.script.resources2);
        } else {
            console.log("[lou-extensions] ERROR: No resources found in MetaData block. No scripts injected");
        }
    } catch (e) {
        console.log("[lou-extensions] ERROR: " + e.toSource());
    }

    /**
     * Analyse the GM_info to find the resource js and injects them.
     * @param resources Array of resource files that are included in lou-extensions
     */
    function loadExtensions(resources) {

        var options = lou_extensions.getOptions(lou_extensions.version);
        var prefixes = lou_extensions.getEnabledPerScriptPrefix(options);

        for (var i in resources) {

            if (resources.hasOwnProperty(i)) {

                var resource = resources[i];
                var checkForPrefix = resource.name.split("/")[0];

                if (prefixes[checkForPrefix]) {

                    console.log('[lou-extensions] Injecting ' + resource.name);

                    // grab contents of resource-file.
                    var resourceContent = GM_getResourceText(resource.name);
                    var mimetype = resource.mimetype;

                    if (mimetype.indexOf('script') != -1) {
                        lou_extensions.injectScript(resourceContent, mimetype, resource.name);

                    } else if (mimetype.indexOf('css') != -1) {
                        lou_extensions.injectStyle(resourceContent, mimetype, resource.name);

                    } else {
                        console.log("[lou-extensions] Cannot inject a resource with this mime-type."
                            + "\n\tResource name: " + resource.name
                            + "\n\tResource mime-type: " + mimetype
                        );
                    }
                }
            }
        }
    }

    /**
     * Gets the GM_info and adds an array of resource names defined in the meta data
     * @returns {Object} GM_info with possibly empty array of resource names
     */
    function getScriptMetaData() {

        //built-in meta data
        var info = GM_info;

        //add resources from meta data
        if (!"script" in info) {
            info.script = {};
        }

        if (!("resources2" in info.script)) {
            info.script.resources2 = {};
            var resources = info.scriptMetaStr.match(/\/\/ @resource.*/g);

            if (resources != null) {
                for (var i = 0; i < resources.length; i++) {
                    var resourceLine = resources[i].split(/\b\s+/);
                    var resourceName = resourceLine[1];
                    var resourceFile = resourceLine[2];
                    var resourceFileExt = /\w+$/g.exec(resourceFile)[0];
                    var resourceMimeType = "";

                    switch (resourceFileExt.toLowerCase()) {
                        case "js":
                            resourceMimeType = "application/javascript";
                            break;
                        case "css":
                            resourceMimeType = "text/css";
                            break;
                        default:
                    }

                    info.script.resources2[resourceName] = {
                        name: resourceName,
                        mimetype: resourceMimeType,
                        src: resourceFile
                    };
                }
            }
        }

        return info;
    }

})(theWindow.lou_extensions);
