loader.addFinishHandler(function () {

    qx.Class.define("paTweak.Main", {
        type: "singleton",
        extend: qx.core.Object,
        members: {
            SEND_WOOD: 1,
            SEND_STONE: 2,
            SEND_BOTH: 3,
            DO_NOT_ATTACK_UNITS: {
                "1": true, // City Guard
                "19": true // Baron
            },
            DO_NOT_PLUNDER_UNITS: {
                "13": true, // Ram
                "14": true, // Catapult
                "2": true // Ballista
            },

            SCOUT_ORDER_ID: 1,
            PLUNDER_ORDER_ID: 2,
            ATTACK_ORDER_ID: 3,
            SUPPORT_ORDER_ID: 4,
            SIEGE_ORDER_ID: 5,
            RAID_ORDER_ID: 8,
            _extraRow: null,
            reportExtraInfo: null,
            coord: null,
            worldContext: null,
            copyMenu: null,
            infoMenu: null,
            selectCityBtn: null,

            cityStatusText: "",
            cityStatusRow: null,

            clearCityStatusText: function () {
                if (cityStatusText && cityStatusRow) {
                    cityStatusRow.setMaxHeight(0);
                    cityStatusText.setMaxHeight(0);
                    cityStatusRow.setVisibility("hidden");
                    cityStatusText.setValue("");
                }
            },

            initialize: function () {

                this.app = qx.core.Init.getApplication();
                this.cInfoView = this.app.getCityInfoView();
                this.chat = this.app.chat;
                this.bQc = this.cInfoView.buildingQueue;
                this.bQh = this.bQc.header;
                this.playerName = webfrontend.data.Player.getInstance().getName()
                var civ_cont = this.cInfoView.container.getChildren();

                // CityCommandInfoView (kindly borrowed from LoU Tweak)
                for (var i = 0; i < civ_cont.length; i++) {
                    if (civ_cont[i].basename == "CityCommandInfoView") {
                        this.cCmdInfoView = civ_cont[i];
                        break;
                    }
                }

                this.tweakPA();
            },
            tweakPA: function () {
                // Create a toolbar in the main area on the left below existing forms.
                this.panel = new paTweak.ui.ExtraTools("MERC Tools v" + paTweak.Version.PAversion);// + ' (' + paTweak.Version.PAcodename + ')');
                this.addPanel(this.panel);
                this._extraRow = this.panel._extraRow

                // Cancel Orders
                this.cancelOrders = new paTweak.ui.CancelOrderPanel();
                this.cCmdInfoView.commandHeaderData.header.add(this.cancelOrders, {left: 160, top: 7});
                var app = qx.core.Init.getApplication();
                this.app = app;
                this.chat = this.app.chat;

                try {
                    var targetContainer = (app.cityDetailView || this.app.getCityDetailView()).actionArea;
                    // Ask BotX
                    var row = new qx.ui.container.Composite();
                    row.setLayout(new qx.ui.layout.HBox(2));
                    targetContainer.add(row);

                    var askBotxHistoryBtn = new qx.ui.form.Button("BotX 3day player history");
                    askBotxHistoryBtn.setToolTipText("Get player history from BotX");
                    //row.add(askBotxHistoryBtn, {flex:1});
                    askBotxHistoryBtn.addListener("execute", function () {
                        var selectedCity = (app.cityDetailView || app.getCityDetailView()).city;
                        var cityPlayerName = selectedCity.get_PlayerName();
                        webfrontend.data.Chat.getInstance().addMsg("/whisper BotX !history " + cityPlayerName);
                    });
                    var askBotxCityBtn = new qx.ui.form.Button("BotX city coords history");
                    askBotxCityBtn.setToolTipText("Get city history from BotX");
                    //row.add(askBotxCityBtn, {flex:1});
                    askBotxCityBtn.addListener("execute", function () {
                        var selectedCity = (app.cityDetailView || app.getCityDetailView()).city;
                        var citycoords = paTweak.CombatTools.cityIdToCoords(selectedCity.get_Coordinates());
                        webfrontend.data.Chat.getInstance().addMsg("/whisper BotX !city " + citycoords[0] + ":" + citycoords[1]);
                    });
                }
                catch (e) {
                    paDebug(e);
                }

                try {
                    var targetContainer = (app.cityDetailView || app.getCityDetailView()).actionArea;
                    var row = new qx.ui.container.Composite();
                    row.setLayout(new qx.ui.layout.HBox(4));
                    targetContainer.add(row);

                    var assaultButton = new qx.ui.form.Button("Attack");
                    assaultButton.orderId = this.ATTACK_ORDER_ID;
                    assaultButton.setToolTipText("Assault selected city with all available units");
                    assaultButton.addListener("execute", this.sendTroops, this);

                    var plunderButton = new qx.ui.form.Button("Plunder");
                    plunderButton.orderId = this.PLUNDER_ORDER_ID;
                    plunderButton.setToolTipText("Plunder selected city with all available units");
                    plunderButton.addListener("execute", this.sendTroops, this);

                    var siegeButton = new qx.ui.form.Button("Siege");
                    siegeButton.orderId = this.SIEGE_ORDER_ID;
                    siegeButton.setToolTipText("Siege selected city with all available units");
                    siegeButton.addListener("execute", this.sendTroops, this);

                    var supportButton = new qx.ui.form.Button("Support");
                    supportButton.orderId = this.SUPPORT_ORDER_ID;
                    supportButton.setToolTipText("Support selected city with all available units");
                    supportButton.addListener("execute", this.sendTroops, this);

                    // add elements
                    row.add(assaultButton, {flex: 1});
                    row.add(plunderButton, {flex: 1});
                    row.add(siegeButton, {flex: 1});
                    row.add(supportButton, {flex: 1});

                    cityStatusRow = new qx.ui.container.Composite();
                    cityStatusRow.setLayout(new qx.ui.layout.HBox());
                    cityStatusText = new qx.ui.basic.Label();
                    cityStatusText.setAlignY("middle");
                    cityStatusText.setRich(true);
                    cityStatusText.setFont("bold");
                    cityStatusRow.setMaxHeight(0);
                    cityStatusText.setMaxHeight(0);
                    cityStatusRow.setVisibility("hidden");
                    cityStatusRow.add(cityStatusText);
                    targetContainer.add(cityStatusRow);
                    mkReq();
                }
                catch (e) {
                    paDebug(e);
                }

                try {
                    this.reportExtraInfo = paTweak.ui.RaidReporter.getInstance()
                    var rep = app.getReportPage();
                    rep.origOnReport = rep._onReport;
                    rep._onReport = this.reportExtraInfo.interceptOnReport;
                } catch (e) {
                    paDebug(e);
                }

                // Boss button
                //this.initBossHunt();
                this.createWorldViewEnhancments();
                this.createRaidApplyToAll();
                this.createContextMenu();
                //FIGUREDOUTif(webfrontend["\x64\x61\x74\x61"]["\x41\x6C\x6C\x69\x61\x6E\x63\x65"]["\x67\x65\x74\x49\x6E\x73\x74\x61\x6E\x63\x65"]()["\x67\x65\x74\x4E\x61\x6D\x65"]() in {
                //webfrontend.data               .Alliance                           .getInstance()										.getName()                        in {
                // "\x53\x65\x72\x70\x65\x6E\x74\x20\x49\x73\x6C\x65":"","\x53\x65\x72\x70\x65\x6E\x74\x73\x20\x4E\x65\x73\x74":""}){
                // "Serpent Isle										  Serpents Nest
            },				// this["\x63\x72\x65\x61\x74\x65\x57\x6F\x72\x6C\x64\x56\x69\x65\x77\x45\x6E\x68\x61\x6E\x63\x6D\x65\x6E\x74\x73"]();
            // this.createWorldViewEnhancments();
            // this["\x63\x72\x65\x61\x74\x65\x52\x61\x69\x64\x41\x70\x70\x6C\x79\x54\x6F\x41\x6C\x6C"]();
            // this.createRaidApplyToAll();
            // this["\x63\x72\x65\x61\x74\x65\x43\x6F\x6E\x74\x65\x78\x74\x4D\x65\x6E\x75"]();} ;
            // this.create?o
            createContextMenu: function () {
                this.worldContext = new qx.ui.menu.Menu();
                this.worldContext.setIconColumnWidth(0);
                this.copyMenu = new qx.ui.menu.Menu();
                this.copyMenu.setIconColumnWidth(0);
                this.infoMenu = new qx.ui.menu.Menu();
                this.infoMenu.setIconColumnWidth(0);
                this.selectCityBtn = new qx.ui.menu.Button("Switch to City");
                this.viewReportsBtn = new qx.ui.menu.Button("View Reports");
                this.killBossBtn = new qx.ui.menu.Button("Kill Boss");
                this.raidDungeonBtn = new qx.ui.menu.Button("Raid");
                //this.raidDungeon1Btn = new qx.ui.menu.Button("Raid 1");
                //this.raidDungeonAllBtn = new qx.ui.menu.Button("Raid all");
                this.sendArmyBtn = new qx.ui.menu.Button("Send Army");
                this.plunderBtn = new qx.ui.menu.Button("Plunder With All");
                this.scoutBtn = new qx.ui.menu.Button("Scout With All");
                this.supportBtn = new qx.ui.menu.Button("Support With All");
                this.copyBtn = new qx.ui.menu.Button("Copy to Chat");
                this.copyBtnSub = new qx.ui.menu.Button("Copy to Chat", null, null, this.copyMenu);
                this.copyCoordBtn = new qx.ui.menu.Button("Coordinates");
                this.copyPlayerBtn = new qx.ui.menu.Button("Player");
                this.copyAllianceBtn = new qx.ui.menu.Button("Alliance");
                this.sendResBtn = new qx.ui.menu.Button("Send Resources");
                //this.infoBtn = new qx.ui.menu.Button("Info", null, null, this.infoMenu);
                this.infoPlayerBtn = new qx.ui.menu.Button("Player Info");
                this.worldContext.add(this.infoPlayerBtn);
                //this.infoAllianceBtn = new qx.ui.menu.Button("Alliance");
                this.whisperBtn = new qx.ui.menu.Button("Whisper");
                this.worldContext.add(this.selectCityBtn);
                this.worldContext.add(this.viewReportsBtn);
                this.worldContext.add(this.killBossBtn);
                this.worldContext.add(this.raidDungeonBtn);
                //this.worldContext.add(this.raidDungeon1Btn);
                //this.worldContext.add(this.raidDungeonAllBtn);
                this.worldContext.add(this.sendArmyBtn);
                this.worldContext.add(this.plunderBtn);
                this.worldContext.add(this.scoutBtn);
                this.worldContext.add(this.supportBtn);
                this.worldContext.add(this.sendResBtn);
                //this.worldContext.add(this.infoBtn);
                this.worldContext.add(this.whisperBtn);
                this.worldContext.add(this.copyBtnSub);
                this.copyMenu.add(this.copyCoordBtn);
                this.copyMenu.add(this.copyPlayerBtn);
                this.copyMenu.add(this.copyAllianceBtn);
                //this.infoMenu.add(this.infoPlayerBtn);
                //this.infoMenu.add(this.infoAllianceBtn);
                qx.core.Init.getApplication().worldView.setContextMenu(this.worldContext);
                qx.core.Init.getApplication().worldView.addListener("beforeContextmenuOpen", function (e) {
                    this.updateWorldViewContext();
                }, this);
                this.plunderBtn.orderId = this.PLUNDER_ORDER_ID;
                this.plunderBtn.addListener("execute", this.sendTroops, this);
                this.scoutBtn.orderId = this.SCOUT_ORDER_ID;
                this.scoutBtn.addListener("execute", this.sendTroops, this);
                this.supportBtn.orderId = this.SUPPORT_ORDER_ID;
                this.supportBtn.addListener("execute", this.sendTroops, this);
                this.sendArmyBtn.addListener("execute", function (e) {
                    if (this.coord && this.coord.attackable) {
                        this.app.showSendArmy(this.coord.xPos, this.coord.yPos);
                    }
                }, this);
                this.killBossBtn.addListener("execute", function (e) {
                    var rw = paTweak.ui.RaidingWindow.getInstance();
                    var rt = rw.pickBossRaider().t;
                    var o = new Object();
                    o.BossType = getBossType(this.coord.playerName);
                    o.BossLevel = this.coord.level;
                    var utk = rw.getUnitsToKill(rt, o);
                    var CI = webfrontend.data.City.getInstance();
                    var uinfo = CI.getUnitTypeInfo(rt);
                    if (utk <= uinfo.count) {
                        var unitsToSend = new Array();
                        unitsToSend.push({
                            t: rt,
                            c: Math.floor(utk)
                        });
                        webfrontend.net.CommandManager.getInstance().sendCommand("OrderUnits", {
                            cityid: webfrontend.data.City.getInstance().getId(),
                            units: unitsToSend,
                            targetPlayer: "",
                            targetCity: this.coord.xPos + ":" + this.coord.yPos,
                            order: 8,
                            transport: 1,
                            timeReferenceType: 1,
                            referenceTimeUTCMillis: 0,
                            raidTimeReferenceType: 0,
                            raidReferenceTimeUTCMillis: 0
                        });
                    }
                }, this);
                this.sendResBtn.addListener("execute", function (e) {
                    if (this.coord && this.coord.city) {
                        this.app.showTrade(this.coord.xPos, this.coord.yPos);
                    }
                }, this);
                this.selectCityBtn.addListener("execute", function (e) {
                    if (this.coord && this.coord.city && this.coord.playerName == this.playerName) {
                        var cityList = qx.core.Init.getApplication().cityBar.citiesSelect;
                        cityList.setSelectedCityId(this.coord.id);
                    }
                }, this);
                this.viewReportsBtn.addListener("execute", function (e) {
                    if (this.coord && this.coord.type) {
                        this.app.showInfoPage(this.app.getCityInfoPage(), { "id": this.coord.id });
                    }
                }, this);
                this.raidDungeonBtn.addListener("execute", function (e) {
                    if (this.coord && this.coord.dungeon) {
                        var dialog = paTweak.ui.RaidingWindow.getInstance();
                        var w = qx.bom.Viewport.getWidth(window);
                        var h = qx.bom.Viewport.getHeight(window);
                        var wh = Math.floor(h * 0.45);
                        dialog.setWidth(500);
                        dialog.setHeight(400);
                        dialog.show();
                        dialog.moveTo(w - 500, h - 450);
                    }
                }, this);
                this.infoPlayerBtn.addListener("execute", function (e) {
                    if (this.coord && this.coord.type) {
                        this.app.showInfoPage(this.app.getPlayerInfoPage(), { "name": this.coord.playerName });
                    }
                }, this);
                /*
                 this.infoAllianceBtn.addListener("execute", function (e) {
                 if (this.coord && this.coord.type) {
                 this.app.showInfoPage(this.app.getAllianceInfoPage(), { "name": this.coord.allianceName });
                 }
                 }, this);
                 */
                this.copyBtnSub.addListener("execute", function (e) {
                    if (this.coord) {
                        this.sendToChat("[city]" + webfrontend.gui.Util.formatCoordinates(this.coord.xPos, this.coord.yPos) + "[/city]");
                    }
                }, this);
                this.copyCoordBtn.addListener("execute", function (e) {
                    if (this.coord) {
                        this.sendToChat("[coords]" + webfrontend.gui.Util.formatCoordinates(this.coord.xPos, this.coord.yPos) + "[/coords]");
                    }
                }, this);
                this.copyPlayerBtn.addListener("execute", function (e) {
                    if (this.coord && this.coord.city) {
                        this.sendToChat("[player]" + this.coord.playerName + "[/player]");
                    }
                }, this);
                this.copyAllianceBtn.addListener("execute", function (e) {
                    if (this.coord && this.coord.city) {
                        this.sendToChat("[alliance]" + this.coord.allianceName + "[/alliance]");
                    }
                }, this);
            },
            sendToChat: function (msg, overWrite) {
                var str = "";
                if (!overWrite && this.chat && this.chat.chatLine.getValue()) {
                    str = this.chat.chatLine.getValue();
                    str = str.substr(0, this.chat.chatLine.getTextSelectionStart()) + msg + str.substr(this.chat.chatLine.getTextSelectionEnd());
                    msg = "";
                }
                this.chat.chatLine.setValue(str + msg);
            },
            updateWorldViewContext: function () {
                this.selectCityBtn.setVisibility("excluded");
                this.infoPlayerBtn.setVisibility("excluded");
                this.viewReportsBtn.setVisibility("excluded");
                this.killBossBtn.setVisibility("excluded");
                this.raidDungeonBtn.setVisibility("excluded");
                //this.raidDungeon1Btn.setVisibility("excluded");
                //this.raidDungeonAllBtn.setVisibility("excluded");
                this.sendArmyBtn.setVisibility("excluded");
                this.plunderBtn.setVisibility("excluded");
                this.scoutBtn.setVisibility("excluded");
                this.sendResBtn.setVisibility("excluded");
                this.copyBtn.setVisibility("excluded");
                this.copyBtnSub.setVisibility("excluded");
                this.supportBtn.setVisibility("excluded");
                //this.infoBtn.setVisibility("excluded");
                this.whisperBtn.setVisibility("excluded");
                if (this.app.visMain.mapmode == "r" || this.app.visMain.mapmode == "w") {
                    this.coord = this.updateWorldViewCoord();
                    this.sendArmyBtn.setVisibility(this.coord.attackable && (this.coord.city || this.coord.lawless) && this.coord.playerName != this.playerName ? "visible" : "excluded");
                    this.plunderBtn.setVisibility(this.coord.attackable && (this.coord.city || this.coord.lawless) && this.coord.playerName != this.playerName ? "visible" : "excluded");
                    this.scoutBtn.setVisibility(this.coord.attackable && (this.coord.city || this.coord.lawless) && this.coord.playerName != this.playerName ? "visible" : "excluded");
                    this.supportBtn.setVisibility(this.coord.attackable && (this.coord.city || this.coord.lawless) ? "visible" : "excluded");
                    this.sendArmyBtn.setVisibility(this.coord.attackable && (this.coord.city || this.coord.lawless) && this.coord.playerName != this.playerName ? "visible" : "excluded");
                    this.viewReportsBtn.setVisibility(this.coord.attackable ? "visible" : "excluded");
                    this.selectCityBtn.setVisibility(this.coord.city && this.coord.playerName == this.playerName ? "visible" : "excluded");
                    this.infoPlayerBtn.setVisibility(this.coord.city && this.coord.playerName ? "visible" : "excluded");
                    this.sendResBtn.setVisibility(this.coord.city && this.coord.playerName ? "visible" : "excluded");
                    this.killBossBtn.setVisibility(this.coord.boss ? "visible" : "excluded");
                    this.raidDungeonBtn.setVisibility(this.coord.dungeon ? "visible" : "excluded");
                    this.copyBtn.setVisibility(this.coord ? "visible" : "excluded");
                    this.copyBtnSub.setVisibility(this.coord ? "visible" : "excluded");
                    this.copyPlayerBtn.setVisibility(this.coord && this.coord.city && this.coord.playerName ? "visible" : "excluded");
                    this.copyAllianceBtn.setVisibility(this.coord && this.coord.allianceName ? "visible" : "excluded");
                }
            },
            updateWorldViewCoord: function () {
                if (this.worldViewCoord == null) {
                    this.worldViewCoord = new Object();
                }
                var worldViewToolTip = this.app.worldViewToolTip;
                var id = 0;
                var playerName = null;
                var allianceName = "";
                var type = null;
                var xPos = worldViewToolTip.x - worldViewToolTip.getWorldView().getContentLocation().left;
                var yPos = worldViewToolTip.y - worldViewToolTip.getWorldView().getContentLocation().top;
                var xCoord = worldViewToolTip.getVisMain().GetXCoordFromViewPosition(xPos);
                var yCoord = worldViewToolTip.getVisMain().GetYCoordFromViewPosition(yPos);

                var tooltipText = worldViewToolTip.getVisMain().GetTooltipText(xPos, yPos);

                var level = 0;
                var progress = 0;
                if (tooltipText.match(/<td>Player:<\/td><td>(.+?) <span dir="ltr">(.+?)<\/td>/)) {
                    playerName = tooltipText.match(/<td>Player:<\/td><td>(.+?) <span dir="ltr">(.+?)<\/td>/)[1];
                    if (tooltipText.match(/<td>Alliance:<\/td><td>(.+?) <span dir="ltr">(.+?)<\/td>/)) {
                        allianceName = tooltipText.match(/<td>Alliance:<\/td><td>(.+?) <span dir="ltr">(.+?)<\/td>/)[1];
                    }
                    type = "City";
                } else if (tooltipText.match(/<td>Score:<\/td><td>.+?<\/td>/)) {
                    type = "LawlessCity";
                } else if (tooltipText.match(/<td width="75">Type:<\/td><td>.+?<\/td>/)) {
                    type = "Dungeon";
                    if (tooltipText.match(/<td>Level:<\/td><td>(.+?)<\/td>/)) {
                        level = tooltipText.match(/<td>Level:<\/td><td>(.+?)<\/td>/)[1];
                    }
                    if (tooltipText.match(/<td>Progress:<\/td><td>(.+?)%<\/td>/)) {
                        progress = tooltipText.match(/<td>Progress:<\/td><td>(.+?)%<\/td>/)[1];
                    }
                } else if (tooltipText.match(/<td width="75">Name:<\/td><td>.+?<\/td>/)) {
                    type = "Boss";
                    if (tooltipText.match(/<td>Level:<\/td><td>(.+?)<\/td>/)) {
                        level = tooltipText.match(/<td>Level:<\/td><td>(.+?)<\/td>/)[1];
                    }
                    if (tooltipText.match(/<td width="75">Name:<\/td><td>(.+?)<\/td>/)) {
                        playerName = tooltipText.match(/<td width="75">Name:<\/td><td>(.+?)<\/td>/)[1];
                    }
                } else {
                    type = "FreeSlot";
                }

                this.worldViewCoord.id = (yCoord << 0x10) | xCoord;
                this.worldViewCoord.xPos = xCoord;
                this.worldViewCoord.yPos = yCoord;
                this.worldViewCoord.playerName = playerName;
                this.worldViewCoord.allianceName = allianceName;
                this.worldViewCoord.type = type;
                this.worldViewCoord.level = level;
                this.worldViewCoord.progress = progress;
                this.worldViewCoord.city = type == "City";
                this.worldViewCoord.lawless = type == "LawlessCity";
                this.worldViewCoord.boss = type == "Boss";
                this.worldViewCoord.dungeon = type == "Dungeon";
                this.worldViewCoord.attackable = (type == "City" || type == "Boss" || type == "Dungeon" || type == "LawlessCity");
                return this.worldViewCoord;
            },
            sendTroops: function (event) {
                try {
                    try {
                        var clicked = event.getCurrentTarget();

                        var activeCity = webfrontend.data.City.getInstance();

                        var app = qx.core.Init.getApplication();
                        var selectedCity = (app.cityDetailView || app.getCityDetailView()).city;

                        var units = activeCity.units;
                        var unitsOrdered = [];
                        for (var u in units) {
                            if (this.DO_NOT_ATTACK_UNITS[u])
                                continue;
                            if (clicked.orderId == this.PLUNDER_ORDER_ID && this.DO_NOT_PLUNDER_UNITS[u])
                                continue;
                            if (units[u].count > 0)
                                unitsOrdered.push({t: u, c: units[u].count});
                        }
                        var coords = paTweak.CombatTools.cityIdToCoords(selectedCity ? selectedCity.get_Coordinates() : this.worldViewCoord.id);
                        var request = {
                            cityid: activeCity.getId(),
                            units: unitsOrdered,
                            targetPlayer: selectedCity ? selectedCity.get_PlayerName() : this.worldViewCoord.playerName,
                            targetCity: coords[0] + ":" + coords[1],
                            order: clicked.orderId,
                            transport: 1,
                            timeReferenceType: 1,
                            referenceTimeUTCMillis: 0,
                            raidTimeReferenceType: 0,
                            raidReferenceTimeUTCMillis: 0
                        };
                        var commandManager = webfrontend.net.CommandManager.getInstance();
                        commandManager.sendCommand("OrderUnits", request, this, this.sentTroops);
                    }
                    catch (err) {
                        paDebug(String(err));
                    }
                } catch (e) {
                    paDebug(e);
                }
            },
            sentTroops: function (ok, errorCode) {
                try {

                    if (errorCode.r0 != 0) {
                        if (cityStatusText) {
                            cityStatusRow.setMaxHeight(20);
                            cityStatusText.setMaxHeight(20);
                            cityStatusRow.setVisibility("visible");
                            cityStatusText.setValue("Troops won't go.");
                            window.setTimeout(clearCityStatusText, 2000);
                        }
                        window.console.debug("Troops won't go");
                    }
                    else {
                        if (cityStatusText) {
                            cityStatusRow.setMaxHeight(20);
                            cityStatusText.setMaxHeight(20);
                            cityStatusRow.setVisibility("visible");
                            cityStatusText.setValue("Troops Sent.");
                            window.setTimeout(clearCityStatusText, 2000);
                        }
                    }

                } catch (e) {
                    paDebug(e);
                }
            },
            createRaidApplyToAll: function () {
                var orderPage = this.app.getOrderDetailPage();
                orderPage.applyAllBtn = new webfrontend.ui.SoundButton("Apply to all");
                orderPage.applyAllThisDungeonBtn = new webfrontend.ui.SoundButton("Apply to all this dungeon");
                orderPage.applyAllBtn.onTroopsSent = this.onTroopsSent;
                orderPage.applyAllBtn.addListener("execute", function (e) {
                    var currRecurrType = orderPage.raidUntilDropdown.getSelection()[0].getModel();
                    var orders = webfrontend.data.City.getInstance().unitOrders;
                    var endStep = orderPage.calculateTimeInputStep();
                    for (var i in orders) {
                        if (orders[i].type == 8) {
                            webfrontend.net.CommandManager.getInstance().sendCommand("UnitOrderSetRecurringOptions", {
                                cityid: webfrontend.data.City.getInstance().getId(),
                                id: orders[i].id,
                                isDelayed: orders[i].isDelayed,
                                recurringType: currRecurrType,
                                recurringEndStep: endStep
                            }, this, this.onTroopsSent);
                        }
                    }
                });
                orderPage.applyAllThisDungeonBtn.onTroopsSent = this.onTroopsSent;
                orderPage.applyAllThisDungeonBtn.addListener("execute", function (e) {
                    var currRecurrType = orderPage.raidUntilDropdown.getSelection()[0].getModel();
                    var city = orderPage.command.city;
                    var orders = webfrontend.data.City.getInstance().unitOrders;
                    var endStep = orderPage.calculateTimeInputStep();
                    for (var i in orders) {
                        if (orders[i].type == 8 && orders[i].city == city) {
                            webfrontend.net.CommandManager.getInstance().sendCommand("UnitOrderSetRecurringOptions", {
                                cityid: webfrontend.data.City.getInstance().getId(),
                                id: orders[i].id,
                                isDelayed: orders[i].isDelayed,
                                recurringType: currRecurrType,
                                recurringEndStep: endStep
                            }, this, this.onTroopsSent);
                        }
                    }
                });
                orderPage._createSaveOptionsOrig = orderPage._createSaveOptions;
                orderPage._createSaveOptions = function () {
                    var rtnVal = orderPage._createSaveOptionsOrig();
                    rtnVal.remove(orderPage.btnApplyChanges);
                    rtnVal.add(orderPage.applyAllBtn);
                    rtnVal.add(orderPage.applyAllThisDungeonBtn);
                    rtnVal.add(orderPage.btnApplyChanges);
                    return rtnVal;
                }
            },
            onTroopsSent: function (ok, errorCode) {
                try {
                    if (!ok) {
                        if (errorCode != 0) {
                            window.console.debug("Troops won't go");
                        }
                    }
                } catch (e) {
                    paDebug("onTroopsSent: " + e);
                }
            },
            createWorldViewEnhancments: function () {
                this.worldViewMinBtn = new webfrontend.ui.SoundButton("").set({
                    icon: "webfrontend/ui/icons/icon_chat_resize_smaller.png",
                    padding: 4,
                    minWidth: 10,
                    width: 29
                });
                this.worldViewMinBtn.setLayoutProperties({
                    top: 3,
                    right: 9
                });
                this.worldViewMinBtn.addListener("execute", function (e) {
                    if (this.app.worldMapConfig.getLayoutProperties().top > 0) {
                        this.app.worldMapConfig.setLayoutProperties({
                            top: null,
                            height: 4
                        });
                        this.worldViewMinBtn.setIcon("webfrontend/ui/icons/icon_chat_resize.png");
                    } else {
                        this.app.worldMapConfig.setLayoutProperties({
                            top: 187,
                            height: null
                        });
                        this.worldViewMinBtn.setIcon("webfrontend/ui/icons/icon_chat_resize_smaller.png");
                    }
                }, this);
                this.worldViewMinBtn.addListener("appear", function (e) {
                    if (this.app.worldMapConfig.getLayoutProperties().top > 0) {
                        this.worldViewMinBtn.setIcon("webfrontend/ui/icons/icon_chat_resize_smaller.png");
                    } else {
                        this.worldViewMinBtn.setIcon("webfrontend/ui/icons/icon_chat_resize.png");
                    }
                }, this);
                if (this.app.worldMapConfig == null) {
                    this.app.worldMapConfig = new webfrontend.gui.WorldMapConfig().set({
                        width: 400
                    });
                    this.app.worldMapConfig.setLayoutProperties({
                        top: 187,
                        left: 0,
                        bottom: 0
                    });
                }
                this.app.worldMapConfig.setMinHeight(0);
                this.app.worldMapConfig.add(this.worldViewMinBtn);
            },
            addPanel: function (panel) {
                this.bQc.getLayoutParent().addBefore(panel, this.bQc);
            },
            initBossHunt: function () {
                var app = qx.core.Init.getApplication();
                var container = (app.dungeonDetailView || app.getDungeonDetailView()).actionArea;
                var buttonLayout = new qx.ui.layout.VBox(3);
                var btnRow = new qx.ui.container.Composite(buttonLayout);
                if (btnRow) {
                    btnRow.set({ maxWidth: 306 });
                    // Hunt
                    var attackBtn = new qx.ui.form.Button("ATTACK Boss");
                    attackBtn.addListener("execute", function () {
                        if ((app.dungeonDetailView || app.getDungeonDetailView()).city.get_Active()) {
                            var coordsId = (app.dungeonDetailView || app.getDungeonDetailView()).city.get_Coordinates();
                            var coords = paTweak.CombatTools.cityIdToCoords(coordsId);
                            paTweak.BossUtils.sendAttack(coords[0], coords[1]);
                        }

                        attackBtn.setEnabled(false);
                        window.setTimeout(function () {
                            attackBtn.setEnabled(true);
                        }, 4000);
                    });
                    btnRow.add(attackBtn);

                    // Ask BotX
                    var askBotxBtn = new qx.ui.form.Button("Ask BotX");
                    askBotxBtn.addListener("execute", function () {
                        var coordsId = webfrontend.data.City.getInstance().getId();
                        var coords = paTweak.CombatTools.cityIdToCoords(coordsId);
                        webfrontend.data.Chat.getInstance().addMsg("/whisper BotX !hunt " + coords[0] + ":" + coords[1]);

                        askBotxBtn.setEnabled(false);
                        window.setTimeout(function () {
                            askBotxBtn.setEnabled(true);
                        }, 4000);
                    });
                    //btnRow.add(askBotxBtn);

                    // Add to screen
                    container.addAt(btnRow, 1);
                }
            }
        }
    });

});