loader.addFinishHandler(function () {

    qx.Class.define("paTweak.ui.AboutWindow", {
        type: "singleton",
        extend: qx.ui.window.Window,
        construct: function () {
            this.base(arguments, 'MERC Tools v' + paTweak.Version.PAversion);
            this.buildUI();

            // Refresh dev info every time
            this.addListener("appear", this.loadDeveloperInfo, this);
        },
        members: {
            _developerInfoText: null,

            buildUI: function () {
                var app = qx.core.Init.getApplication();

                this.setLayout(new qx.ui.layout.VBox(10));
                this.set({allowMaximize: false, allowMinimize: false, showMaximize: false, showMinimize: false,
                    showStatusbar: false, showClose: false, contentPadding: 5, useMoveFrame: true, resizable: true});
                this.setWidth(400);
                webfrontend.gui.Util.formatWinClose(this);

                // Licensing
                var licenseLabel = new qx.ui.basic.Label("License").set({font: "bold"});
                this.add(licenseLabel);

                var license = "MERC Tools - GreaseMonkey script for Lord of Ultima™";
                license += "\nCopyright © 2012 " + paTweak.Version.PAauthors;
                license += "\n\nPortions copyright " + paTweak.Version.PAcontrib;
                license += "\n\n";
                license += paTweak.Version.GPL;

                var licenseText = new qx.ui.form.TextArea();
                licenseText.set({readOnly: true, wrap: true, autoSize: true, tabIndex: 303, minHeight: 280});
                licenseText.setValue(license);
                this.add(licenseText);

                // Developer Info
                var devInfoLabel = new qx.ui.basic.Label("Developer Info").set({font: "bold"});
                devInfoLabel.setToolTipText("Date of add-on build: " + paTweak.Version.PAbuild);
                this.add(devInfoLabel);
                //DISABLE var siImg = new qx.ui.basic.Image("http://ab6s.com/l/siImg.aspx");
                //DISABLE this.add(siImg);

                var devInfoText = this._developerInfoText = new qx.ui.form.TextArea();
                devInfoText.set({readOnly: true, autoSize: true, tabIndex: 304, height: 50});
                app.setElementModalInput(devInfoText);
                this.add(devInfoText);

                // Close button
                var closeButton = new qx.ui.form.Button("Close");
                closeButton.addListener("execute", this.hide, this);
                this.add(closeButton);
            },
            loadDeveloperInfo: function () {
                // Code provided by MousePak
                var output = 'Session ID: ' + webfrontend.net.CommandManager.getInstance().getInstanceGuid() + '\n';
                output += 'City ID: ' + webfrontend.data.City.getInstance().getId() + '\n';

                this._developerInfoText.setValue(output);
                this._developerInfoText.selectAllText();
            }
        }
    });
});
