loader.addFinishHandler(function () {

    qx.Class.define("paTweak.ui.AllianceMailingListWindow", {
        type: "singleton",
        extend: qx.ui.window.Window,
        construct: function (cityAllianceName, cityAllianceID) {
            this.base(arguments, 'Mailing Lists');
            this.buildUI();

            // Refresh info every time
            this.addListener("appear", this.getAllianceMailingLists, this);
        },
        members: {
            _wcText: null,
            _lists: null,
            _continents: null,
            _count: 0,
            buildUI: function () {
                var app = qx.core.Init.getApplication();

                this.setLayout(new qx.ui.layout.VBox(10));
                this.set({allowMaximize: false, allowMinimize: false, showMaximize: false, showMinimize: false,
                    showStatusbar: false, showClose: false, contentPadding: 5, useMoveFrame: true, resizable: true});
                this.setWidth(400);
                webfrontend.gui.Util.formatWinClose(this);

                var wcLabel = new qx.ui.basic.Label("Alliance Mailing Lists").set({font: "bold"});
                this.add(wcLabel);

                this._wcText = new qx.ui.form.TextArea();
                this._wcText.set({readOnly: true, allowGrowY: false, autoSize: false, tabIndex: 303, height: 280});
                app.setElementModalInput(this._wcText);
                this._wcText.setValue("Loading...");
                this.add(this._wcText);

                // Close button
                var closeButton = new qx.ui.form.Button("Close");
                closeButton.addListener("execute", this.hide, this);
                this.add(closeButton);
            },
            getAllianceMailingLists: function () {
                var allianceID = webfrontend.data.Alliance.getInstance().getId();
                this._count = 0;
                // Send command
                var commandManager = webfrontend.net.CommandManager.getInstance();
                commandManager.sendCommand("GetPublicAllianceMemberList", {id: allianceID}, this, this.gotAlliancePlayers);
            },
            gotAlliancePlayers: function (ok, response) {
                if (ok) {
                    this._lists = new Array();
                    this._continents = new Array();
                    var commandManager = webfrontend.net.CommandManager.getInstance();
                    this._count = response.length;
                    for (var ii = 0; ii < response.length; ++ii) {
                        commandManager.sendCommand("GetPublicPlayerInfo", {id: response[ii].i}, this, this.gotPlayerInfo);
                    }
                }
            },
            gotPlayerInfo: function (ok, response) {
                --this._count;
                if (ok) {
                    var server = webfrontend.data.Server.getInstance();
                    var str = this._wcText.getValue();
                    var cities = response.c;
                    for (var ii = 0; ii < cities.length; ++ii) {
                        var continent = server.getContinentFromCoords(cities[ii].x, cities[ii].y)
                        var found = false;
                        for (var a = 0; a < this._continents.length; ++a) {
                            if (this._continents[a] == continent) {
                                found = true;
                                break;
                            }
                        }
                        if (!found) {
                            this._continents[this._continents.length] = continent;
                        }
                        if (!this._lists[continent]) {
                            this._lists[continent] = "";
                        }
                        if (this._lists[continent].indexOf(response.n) < 0) {
                            this._lists[continent] += (this._lists[continent].length > 0 ? ";" : "") + response.n;
                        }
                    }
                    if (this._count == 0) {
                        var str = "";
                        this._wcText.setValue(str);
                        for (var ii = 0; ii < this._continents.length; ++ii) {
                            this._wcText.setValue(this._wcText.getValue() + "Continent " + this._continents[ii] + "\r\n" + this._lists[this._continents[ii]] + "\r\n\r\n");
                        }
                    }
                }
            }
        }
    });
});