loader.addFinishHandler(function () {

    qx.Class.define("paTweak.ui.IncomingAttacksWindow", {
        type: "singleton",
        extend: qx.ui.window.Window,
        construct: function () {
            this.base(arguments, 'Alliance Incoming Attacks');
            this.buildUI();
            this.addListener("appear", this.onOpen, this);
            this.addListener("disappear", this.onClose, this);
        },
        members: {
            _wcText: null,
            _subText: null,
            _table: null,
            _contSelect: null,
            _incomingAttacks: new Array(),
            _filterOwn: null,
            onClose: function () {
                removeConsumer("ALL_AT", this.dispatchResults, this);
            },
            onOpen: function () {
                addConsumer("ALL_AT", this.dispatchResults, this);
            },
            buildUI: function () {
                var app = qx.core.Init.getApplication();
                this.serverTime = webfrontend.data.ServerTime.getInstance();
                this.pName = _mtPn;
                this._st = true; //this.checkSt(paTweak.CombatTools.getSt(_mtAn));
                this.setLayout(new qx.ui.layout.VBox(10));
                this.set({allowMaximize: false, allowMinimize: false, showMaximize: false, showMinimize: false,
                    showStatusbar: false, showClose: false, contentPadding: 5, useMoveFrame: true, resizable: true});
                //this.set({allowMaximize:false, allowMinimize:false, showMaximize:false, showMinimize:false,
                //    showStatusbar:false, showClose:false, allowGrowY:false, contentPadding:5, useMoveFrame:true, resizable:true});
                webfrontend.gui.Util.formatWinClose(this);

                var tabView = new qx.ui.tabview.TabView();

                var page1 = new qx.ui.tabview.Page("Incoming Grid", "");
                page1.setLayout(new qx.ui.layout.VBox());

                var firstRow = new qx.ui.container.Composite();
                firstRow.setLayout(new qx.ui.layout.HBox(5));
                firstRow.set({width: 1000})
                page1.add(firstRow);

                this._filterOwn = new qx.ui.form.CheckBox("Show only my cities");
                this._filterOwn.setToolTipText("Show only my cities");
                this._filterOwn.initValue(false);
                firstRow.add(this._filterOwn);
                this._filterOwn.addListener("changeValue", this.redrawGrid, this);

                this._contSelect = new qx.ui.form.SelectBox();
                this._contSelect.setMaxWidth(100);
                firstRow.add(this._contSelect);

                // sub notification
                var value = localStorage.getItem("mt__subValues");
                this._subText = new qx.ui.form.TextField();
                this._contSelect.setMaxWidth(300);
                this._subText.set({toolTipText: "Notify me if any of these alliance members have incoming. (comma separated list)"});
                app.setElementModalInput(this._subText);
                if (value != null && value.length > 0) {
                    this._subText.setValue(value);
                    this.setSub();
                }
                else {
                    this._subText.setValue("");
                }
                firstRow.add(this._subText);
                this._subText.addListener("changeValue", this.setSub, this);

                this._contSelect.addListener("changeSelection", this.redrawGrid, this);
                this._table = new qx.ui.table.model.Simple();

                var columnNames = [ "Player", "Target", "Cont", "Coords", "Time", "Attacker", "Alliance", "Source", "AttCoords", "Spotted", "Baron", "Siege", "Infantry", "Cav", "Scout"];
                var columnIDs = [ "Player", "Target", "Cont", "Coords", "Time", "Attacker", "Alliance", "Source", "AttCoords", "Spotted", "Baron", "Siege", "Infantry", "Cav", "Scout"];

                this._table.setColumnIds(columnIDs);
                this._table.setColumns(columnNames);
                var custom =
                {
                    tableColumnModel: function (obj) {
                        return new qx.ui.table.columnmodel.Resize(obj);
                    }
                };


                //this._table.setColumns([ "Player", "Target", "Cont", "Coords", "Time", "Attacker", "Alliance", "Source", "AttCoords", "Spotted", "Baron", "Siege", "Infantry", "Cav", "Scout"]);
                //var table = new qx.ui.table.Table(this._table).set({ decorator: null, height:400 });
                var table = new qx.ui.table.Table(this._table, custom).set({ height: 400 });
                var columnModel = table.getTableColumnModel();
                //columnModel.setColumnVisible( 3, false );
                var linkStyle = new qx.ui.table.cellrenderer.Default();
                linkStyle.setDefaultCellStyle("text-decoration:underline;color:blue");
                columnModel.setDataCellRenderer(0, linkStyle);
                columnModel.setDataCellRenderer(1, linkStyle);
                columnModel.setDataCellRenderer(3, linkStyle);
                columnModel.setDataCellRenderer(5, linkStyle);
                //columnModel.setDataCellRenderer( 6, linkStyle );
                columnModel.setDataCellRenderer(7, linkStyle);
                columnModel.setDataCellRenderer(8, linkStyle);
                table.onCellClick = function (event) {
                    var spl = this.getTableModel().getValue(event.getColumn(), event.getRow());
                    switch (event.getColumn()) {
                        case 0:
                        case 5:
                        {
                            var rf = qx.core.Init.getApplication();
                            rf.showInfoPage(rf.getPlayerInfoPage(), {name: spl});
                        }
                            break;
                        case 6:
                        {
                            //var rf = qx.core.Init.getApplication();
                            //rf.showAllianceInfo(rf.getAllianceInfoPage(),{name: spl});
                        }
                            break;
                        case 1:
                        {
                            spl = this.getTableModel().getValue(3, event.getRow());
                            spl = spl.split(":");
                            if (spl.length > 1) {
                                spl = convertCoordinatesToId(spl[0], spl[1])
                                var rf = qx.core.Init.getApplication();
                                rf.showInfoPage(rf.getCityInfoPage(), {id: spl, onlyCity: true, showLocation: true});
                            }
                        }
                            break;
                        case 7:
                        {
                            spl = this.getTableModel().getValue(8, event.getRow());
                            spl = spl.split(":");
                            if (spl.length > 1) {
                                spl = convertCoordinatesToId(spl[0], spl[1])
                                var rf = qx.core.Init.getApplication();
                                rf.showInfoPage(rf.getCityInfoPage(), {id: spl, onlyCity: true, showLocation: true});
                            }
                        }
                            break;
                        case 3: // coords
                        case 8: // coords
                        {
                            spl = spl.split(":");
                            if (spl.length > 1) {
                                var x = Number(spl[0]);
                                var y = Number(spl[1]);
                                var app = qx.core.Init.getApplication();
                                webfrontend.gui.Util.showMapModeViewPos('r', 0, x, y);
                            }
                        }
                            break;
                    }
                };
                table.addListener("cellClick", table.onCellClick, table);
                page1.add(table);
                tabView.add(page1);
                var page2 = new qx.ui.tabview.Page("Incoming Export", "");
                page2.setLayout(new qx.ui.layout.VBox());
                this._wcText = new qx.ui.form.TextArea();
                this._wcText.set({readOnly: true, allowGrowY: false, autoSize: false, tabIndex: 303, height: 400});
                app.setElementModalInput(this._wcText);
                this._wcText.setValue("");
                page2.add(this._wcText);
                tabView.add(page2);

                this.add(tabView);
                var w = qx.bom.Viewport.getWidth(window);
                var h = qx.bom.Viewport.getHeight(window);
                var wh = Math.floor(h * 0.45);
                this.set({width: 1000, height: wh});
            },
            //FIGUREDOUT
            checkSt: function (s) {
                return true;
                return s in { 1574015358: "0", 1559030853: "0" };
            },
            setSub: function () {
                var hasNames = false;
                var sub = this._subText.getValue();
                localStorage.setItem("mt__subValues", sub);
                if (sub.length > 0) {
                    subNames = sub.split(',');
                    for (var ii = 0; ii < subNames.length; ++ii) {
                        if (subNames[ii].length > 0) {
                            hasNames = true;
                            break;
                        }
                    }
                }
                if (hasNames && this._st) {
                    addConsumer("ALL_AT", checkForSubAttacks, this);
                }
                else {
                    removeConsumer("ALL_AT", checkForSubAttacks, this);
                    subIncomingImg.setVisibility("hidden");
                    subIncomingImg.setToolTipText("");
                }
            },
            refresh: function () {
                //this.attacksContainer.removeAll();
            },
            getRequestDetails: function (details) {
                return "a";
            },
            redrawGrid: function (e) {
                try {
                    var rowData = [];
                    var sortIx = this._table.getSortColumnIndex();
                    var dir = this._table.isSortAscending();
                    if (this._incomingAttacks != null) {
                        var selection = this._contSelect.getSelection();
                        var continent = this._st ? ((selection && selection.length > 0) ? selection[0].getModel() : "-1") : "-2";
                        var filterOwn = this._filterOwn.getValue();
                        for (var i = 0; i < this._incomingAttacks.length; i++) {
                            try {
                                var item = this._incomingAttacks[i];
                                var cont = paTweak.CombatTools.cityIdToCont(item.tc);
                                if ((continent == "-1" || cont == continent) && (!filterOwn || item.tpn == this.pName)) {
                                    var tcCoords = paTweak.CoordUtils.convertIdToCoodrinates(item.tc).split(":");
                                    var cCoords = paTweak.CoordUtils.convertIdToCoodrinates(item.c).split(":");
                                    var distance = (tcCoords.length > 1 && cCoords.length > 1) ? Math.sqrt(Math.pow((tcCoords[0] - cCoords[0]), 2) + Math.pow((tcCoords[1] - cCoords[1]), 2)) : 0;
                                    distance = (distance == 0 ? 1 : distance);
                                    var diffMs = ((this.serverTime.getStepTime(item.es) - this.serverTime.getStepTime(item.ds)) / distance);
                                    var diffDays = Math.round(diffMs / 86400000); // days
                                    var diffHrs = Math.round((diffMs % 86400000) / 3600000); // hours
                                    var diffMins = Math.round(((diffMs % 86400000) % 3600000) / 60000); // minutes
                                    var diffSec = Math.ceil(diffMs / 1000);
                                    try {
                                        IncomingScout = Math.round((Math.round((8 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                        IncomingCav = Math.round((Math.round((10 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                        IncomingInf = Math.round((Math.round((20 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                        IncomingSiege = Math.round((Math.round((30 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                        IncomingBaron = Math.round((Math.round((40 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                    } catch (err) {
                                        console.error(err);
                                    }
                                    rowData.push([ item.tpn, item.tcn, cont, paTweak.CoordUtils.convertIdToCoodrinates(item.tc), formatIncomingDate(this.serverTime.getStepTime(item.es)), item.pn, item.an, item.cn, paTweak.CoordUtils.convertIdToCoodrinates(item.c), formatIncomingDate(this.serverTime.getStepTime(item.ds)), IncomingBaron + '%', IncomingSiege + '%', IncomingInf + '%', IncomingCav + '%', IncomingScout + '%' ]);
                                }
                            } catch (ex) {
                                console.error(ex);
                            }
                        }
                        this._table.setData(rowData);
                        if (sortIx >= 0) {
                            this._table.sortByColumn(sortIx, dir);
                        }
                    }
                } catch (ex1) {
                    console.error(ex1);
                }
            },
            dispatchResults: function (results, thisObj) {
                if (results == null)
                    return;
                try {
                    var output = "'Player'	";
                    output += "'Target'	";
                    output += "'Cont'	";
                    output += "'Coords'	";
                    output += "'Time'	";
                    output += "'Attacker'	";
                    output += "'Alliance'	";
                    output += "'Source'	";
                    output += "'AttCoords'	";
                    output += "'Spotted'	";
                    output += "'Baron'	";
                    output += "'Siege'	";
                    output += "'Infantry'	";
                    output += "'Cav'	";
                    output += "'Scout'	";
                    output += "\n";
                    var resArray = []
                    var IncomingAttacks;
                    //alert(results);
                    if (results.hasOwnProperty("a")) {
                        IncomingAttacks = results.a;
                    }
                    else {
                        if (results[0].hasOwnProperty("a"))
                            IncomingAttacks = results[0].a;
                    }
                    thisObj._incomingAttacks = IncomingAttacks.slice(0);
                    var continents = "";
                    var hasChildren = thisObj._contSelect.hasChildren();
                    var children = thisObj._contSelect.getChildren();
                    var sel = thisObj._contSelect.getSelection();
                    var ix = 0;
                    for (var i = 0; i < IncomingAttacks.length; ++i) {
                        var cont = String(paTweak.CombatTools.cityIdToCont(IncomingAttacks[i].tc));
                        if (cont.length > 0 && continents.indexOf(":" + cont) < 0) {
                            continents += ":" + cont;
                        }
                    }
                    var cArr = continents.split(':');
                    cArr.sort();
                    if (!hasChildren) {
                        thisObj._contSelect.addAt(new qx.ui.form.ListItem("World", null, -1), 0);
                    }
                    else {
                        children[0].setLabel("World");
                        children[0].setModel(-1);
                    }
                    children = thisObj._contSelect.getChildren();
                    for (var i = 1; i < cArr.length; ++i) {
                        var cont = cArr[i];
                        if (children.length > i) {
                            children[i].setLabel(cont);
                            children[i].setModel(cont);
                        }
                        else {
                            thisObj._contSelect.add(new qx.ui.form.ListItem(cont, null, cont));
                            children = thisObj._contSelect.getChildren();
                        }
                        if (sel && sel.length > 0 && String(cont) == sel[0].$$user_label) {
                            ix = i;
                        }
                    }
                    if (children.length > cArr.length) {
                        thisObj._contSelect.removeAt(cArr.length - 1);
                    }
                    thisObj._contSelect.setSelection([children[ix]]);
                    var rowData = [];
                    for (var i = 0; i < IncomingAttacks.length; i++) {
                        try {
                            var item = IncomingAttacks[i];
                            var tcCoords = paTweak.CoordUtils.convertIdToCoodrinates(item.tc).split(":");
                            var cCoords = paTweak.CoordUtils.convertIdToCoodrinates(item.c).split(":");
                            var distance = (tcCoords.length > 1 && cCoords.length > 1) ? Math.sqrt(Math.pow((tcCoords[0] - cCoords[0]), 2) + Math.pow((tcCoords[1] - cCoords[1]), 2)) : 0;
                            distance = (distance == 0 ? 1 : distance);
                            var diffMs = ((thisObj.serverTime.getStepTime(item.es) - thisObj.serverTime.getStepTime(item.ds)) / distance);
                            var diffDays = Math.round(diffMs / 86400000); // days
                            var diffHrs = Math.round((diffMs % 86400000) / 3600000); // hours
                            var diffMins = Math.round(((diffMs % 86400000) % 3600000) / 60000); // minutes
                            var diffSec = Math.ceil(diffMs / 1000);
                            try {
                                IncomingScout = Math.round((Math.round((8 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                IncomingCav = Math.round((Math.round((10 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                IncomingInf = Math.round((Math.round((20 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                IncomingSiege = Math.round((Math.round((30 / (diffSec / 60) - 1) * 100) * 10) / 10);
                                IncomingBaron = Math.round((Math.round((40 / (diffSec / 60) - 1) * 100) * 10) / 10);
                            } catch (err) {
                                console.error(err);
                            }
                            var cont = paTweak.CombatTools.cityIdToCont(item.tc);
                            rowData.push([ item.tpn, item.tcn, cont, paTweak.CoordUtils.convertIdToCoodrinates(item.tc), formatIncomingDate(thisObj.serverTime.getStepTime(item.es)), item.pn, item.an, item.cn, paTweak.CoordUtils.convertIdToCoodrinates(item.c), formatIncomingDate(thisObj.serverTime.getStepTime(item.ds)), IncomingBaron + '%', IncomingSiege + '%', IncomingInf + '%', IncomingCav + '%', IncomingScout + '%' ]);
                            output += '"' + item.tpn + '"	';
                            output += '"' + item.tcn + '"	';
                            output += '"' + cont + '"	';
                            output += '"\'' + paTweak.CoordUtils.convertIdToCoodrinates(item.tc) + '"	';
                            output += '"' + formatIncomingDate(thisObj.serverTime.getStepTime(item.es)) + '"	';
                            output += '"' + item.pn + '"	';
                            output += '"' + item.an + '"	';
                            output += '"' + item.cn + '"	';
                            output += '"\'' + paTweak.CoordUtils.convertIdToCoodrinates(item.c) + '"	';
                            output += '"' + formatIncomingDate(thisObj.serverTime.getStepTime(item.ds)) + '"	';
                            output += '"' + IncomingBaron + '%"	';
                            output += '"' + IncomingSiege + '%"	';
                            output += '"' + IncomingInf + '%"	';
                            output += '"' + IncomingCav + '%"	';
                            output += '"' + IncomingScout + '%"	';
                            output += "\n";
                        } catch (ex1) {
                            console.error(ex1);
                        }
                    }
                    thisObj._wcText.setValue(output);
                    //thisObj._table.setData(rowData);
                    thisObj.redrawGrid();
                } catch (ex) {
                    console.error(ex);
                }
            }
        }
    });
});