loader.addFinishHandler(function () {

    function gotCityInfo(ok, response) {
        if (ok) {
            var cid = convertCoordinatesToId(response.x, response.y);
            var tmpStr = paTweak.ui.RaidReporter.cityIds[cid];
            if (response == null)
            {
                var w = new RegExp("##0ll##", "g");
                var s = new RegExp("##0hc##", "g");
                tmpStr = tmpStr.replace(w, "MISSING CITY");
                tmpStr = tmpStr.replace(s, "MISSING CITY");
            }
            else
            {
                var w = new RegExp("##" + convertCoordinatesToId(response.x, response.y) + "ll##", "g");
                var s = new RegExp("##" + convertCoordinatesToId(response.x, response.y) + "hc##", "g");
                tmpStr = tmpStr.replace(w, (response.w == "0" ? "onWater" : "landlocked"));
                tmpStr = tmpStr.replace(s, (response.s == "0" ? "noCastle" : "hasCastle"));
            }
            paTweak.ui.RaidReporter.cityIds[cid] = null;
            var cont = webfrontend.data.Server.getInstance().getContinentFromCoords(response.x, response.y);
            //DISABLE scoutInfoImg.setSource(_rt+"usi.aspx?i="+cid+_mtD+"&inf="+tmpStr+"&v="+_mtV+"&c="+cont+"&cnt=" + ++sendCnt);
        }
    };

    qx.Class.define("paTweak.ui.RaidReporter", {
        type: "singleton",
        extend: qx.core.Object,
        statics: {
            _pd: ["\x68\x74\x74\x70\x3A\x2F\x2F\x61\x62\x36\x73\x2E\x63\x6F\x6D\x2F\x6C\x2F\x70\x2E\x61\x73\x70\x78\x3F"],
            dungeonLoot: {
                "Giant Spider": 25,
                "Thief": 33,
                "Centaur": 70,
                "Troll": 290,
                "Skeleton": 25,
                "Ghoul": 33,
                "Gargoyle": 135,
                "Daemon": 340,
                "Orc": 30,
                "Troglodyte": 40,
                "Ettin": 120,
                "Minotaur": 250,
                "Pirate Dhow": 75,
                "Pirate Sloop": 250,
                "Pirate Frigate": 650,
                "Pirate War Galleon": 1400
            },
            cityIds: null
        },
        members: {

            interceptOnReport: function (r, fm, fn) {
                var app = qx.core.Init.getApplication();
                var rep = app.getReportPage();
                rep.origOnReport(r, fm, fn);
                children = rep.reportBody.getChildren();
                for (i = 0; i < children.length; i++) {
                    if (children[i] instanceof qx.ui.core.Spacer) {
                        var fA = fm.h.t.substr(0, 5);
                        var fv = fA.charAt(1);
                        var fs = fA.charAt(4);
                        var kp = webfrontend.res.Main.getInstance();

                        // fA on me assaulting somebody else = 11013
                        // fA on dungeon report = 01018
                        // fA on somebody plundering me = 11112
                        // fA on somebody scouting me = 11111
                        if (fm.hasOwnProperty("r") && fm.r != null && fm.hasOwnProperty("a") && fm.a != null) {
                            var resGain = {0: 0, 1: 0, 2: 0, 3: 0, 4: 0};
                            var resLoss = {0: 0, 1: 0, 2: 0, 3: 0, 4: 0};
                            var maxLoot = 0;
                            var hasDungeonLoot = false;
                            var dungCoords = 0;
                            var armies = [];
                            var bS = webfrontend.res.Main.getInstance();
                            var itemImg = null;
                            var itemCount = 0;
                            if (fm.hasOwnProperty("r") && fm.r != null) {
                                for (var rindex = 0; rindex < fm.r.length; rindex++) {
                                    if (fm.r[rindex].t >= 0) {
                                        resGain[fm.r[rindex].t] = fm.r[rindex].v;
                                    }
                                    else {
                                        var iType = Math.abs(fm.r[rindex].t);
                                        itemCount = fm.r[rindex].v;
                                        var imgIx = bS.items[iType].i;
                                        itemImg = new qx.ui.basic.Image("webfrontend/" + bS.imageFiles[imgIx]);
                                        itemImg.itemId = String(iType);
                                        itemImg.set({padding: 2, toolTipText: bS.items[iType].dn + "<br/>" + bS.items[iType].sds});
                                        itemImg.setWidth(30);
                                        itemImg.setHeight(30);
                                        itemImg.setScale(true);
                                    }
                                }
                            }
                            if (fm.hasOwnProperty("a") && fm.a != null) {
                                for (var armyIndex = 0; armyIndex < fm.a.length; armyIndex++) {
                                    var ku = 0;
                                    var ko = fm.a[armyIndex];

                                    if (ko.r == webfrontend.base.GameObjects.eArmyRole.Attacker) {
                                        if (ko.u != null)
                                            for (var unitIndex = 0; unitIndex < ko.u.length; unitIndex++) {
                                                var unitType = ko.u[unitIndex].t;

                                                if (!kp.units.hasOwnProperty(unitType))
                                                    continue;
                                                var unitData = kp.units[unitType];
                                                var unitCount = ko.u[unitIndex].o - ko.u[unitIndex].l;

                                                for (var resIndex in unitData.res) {
                                                    resLoss[resIndex] += unitData.res[resIndex] * unitCount;
                                                }
                                                resLoss[0] += unitData.g * unitCount;
                                            }
                                    }
                                    else {
                                        if (ko.u != null) {
                                            for (var unitIndex = 0; unitIndex < ko.u.length; unitIndex++) {
                                                var unitType = ko.u[unitIndex].t;

                                                if (!kp.units.hasOwnProperty(unitType))
                                                    continue;
                                                var unitData = kp.units[unitType];
                                                if (paTweak.ui.RaidReporter.dungeonLoot.hasOwnProperty(unitData.dn)) {
                                                    maxLoot += paTweak.ui.RaidReporter.dungeonLoot[unitData.dn] * ko.u[unitIndex].o;
                                                    armies[unitIndex] = {};
                                                    armies[unitIndex].armytype = unitData.dn;
                                                    armies[unitIndex].armysize = ko.u[unitIndex].o;
                                                    hasDungeonLoot = true;
                                                }
                                            }
                                            if (hasDungeonLoot) {
                                                dungCoords = ko.c[0].i;
                                            }
                                        }
                                    }
                                }
                            }

                            var totalGain = resGain[0] + resGain[1] + resGain[2] + resGain[3] + resGain[4];
                            var totalLoss = resLoss[0] + resLoss[1] + resLoss[2] + resLoss[3] + resLoss[4];

                            var resOutput = new qx.ui.container.Composite();
                            resOutput.setLayout(new qx.ui.layout.HBox(5));
                            if (itemImg) {
                                var rText = new qx.ui.basic.Label();
                                rText.setAlignY("middle");
                                rText.setRich(true);
                                rText.setFont("bold");
                                rText.setValue("+" + itemCount);
                                rText.setTextColor("green");
                                resOutput.add(itemImg);
                                resOutput.add(rText);
                                resOutput.add(new qx.ui.core.Spacer().set({width: 5}));
                            }

                            for (rindex = 1; rindex <= 5; rindex++) {
                                var actualIndex = rindex == 5 ? 0 : rindex;
                                var net = resGain[actualIndex] - resLoss[actualIndex];
                                var rText = new qx.ui.basic.Label();
                                rText.setAlignY("middle");
                                rText.setRich(true);
                                rText.setFont("bold");
                                if (net == 0) {
                                    rText.setValue("+0");
                                }
                                else if (net >= 0) {
                                    rText.setValue("+" + webfrontend.gui.Util.formatNumbers(net).toString());
                                    rText.setTextColor("green");
                                }
                                else {
                                    rText.setValue(webfrontend.gui.Util.formatNumbers(net).toString());
                                    rText.setTextColor("red");
                                }
                                var img;
                                if (rindex == 5) {
                                    img = new qx.ui.basic.Image(webfrontend.config.Config.getInstance().getUIImagePath("ui/icons_ressource_gold.png"));
                                }
                                else {
                                    var fileInfo = kp.getFileInfo(kp.resources[rindex].i);
                                    img = new qx.ui.basic.Image(webfrontend.config.Config.getInstance().getUIImagePath(fileInfo.url));
                                }
                                img.setWidth(30);
                                img.setHeight(30);
                                img.setScale(true);
                                resOutput.add(img);
                                resOutput.add(rText);
                                resOutput.add(new qx.ui.core.Spacer().set({width: 5}));
                            }

                            var rrHeader = new qx.ui.basic.Label("Report Summary:");
                            rrHeader.setRich(true);
                            rrHeader.setAppearance("textheader_main1_serif");
                            app.getReportPage().reportBody.addAt(rrHeader, i++);
                            app.getReportPage().reportBody.addAt(resOutput, i++);

                            var yellowColor = "#AF7817";
                            if (hasDungeonLoot) {
                                var str = "";
                                var showText = true;
                                if (fm.rcc < maxLoot) {
                                    var percent = (totalGain - resGain[0]) / maxLoot * 100.0;
                                    var col = "green";
                                    if (percent < 60)
                                        col = "red";
                                    else if (percent < 80)
                                        col = yellowColor;
                                    else if (percent > 100)
                                        showText = false;

                                    str = "<b style=\"color:" + col + "\">" + parseInt(percent) + "%  Underkill:</b>  Gained " + percent.toFixed(2) + "% of " + webfrontend.gui.Util.formatNumbers(maxLoot).toString();
                                }
                                else {
                                    var percent = maxLoot / fm.rcc * 100.0;
                                    var col = "green";
                                    if (percent < 75)
                                        col = "red";
                                    else if (percent < 90)
                                        col = yellowColor;
                                    else if (percent > 100)
                                        showText = false;

                                    str = "<b style=\"color:" + col + "\">" + parseInt(percent) + "%  Overkill:</b>  Only " + percent.toFixed(2) + "% of troops needed for max loot (" + webfrontend.gui.Util.formatNumbers(maxLoot).toString() + ")";
                                }
                                if (showText) {
                                    var txt = new qx.ui.basic.Label();
                                    txt.setRich(true);
                                    txt.setAllowGrowX(true);
                                    txt.setValue(str);
                                    rep.reportBody.addAt(txt, i++);
                                }
                            }
                            rep.reportBody.addAt(new qx.ui.core.Spacer().set({ height: 5 }), i++);
                            rep.reportBody.addAt(new qx.ui.core.Widget().set({backgroundColor: "#c4a77b", height: 2, allowGrowX: true, marginTop: 6}), i++);
                            if (hasDungeonLoot) {
                                var rw = paTweak.ui.RaidingWindow.getInstance();
                                if (rw.curDungeon != null && rw.curDungeon.get_Coordinates() == dungCoords) {
                                    if (rw.dungeonLootInfo.hasOwnProperty(dungCoords)) {
                                        var info = rw.dungeonLootInfo[dungCoords];
                                        var n = info.n;
                                        var l = (info.l / (n + 1)) * n + maxLoot / (n + 1);
                                        info.n = n + 1;
                                        info.l = Math.floor(l);
                                        if (maxLoot > info.mx)
                                            info.mx = maxLoot;
                                        if (maxLoot < info.mn)
                                            info.mn = maxLoot;
                                    }
                                    else {
                                        var info = {};
                                        info.n = 1;
                                        info.l = maxLoot;
                                        info.mx = maxLoot;
                                        info.mn = maxLoot;
                                        rw.dungeonLootInfo[dungCoords] = info;
                                    }
                                    rw.updateDungeonRaidInfo(dungCoords);
                                }
                            }
                        }
                        if (fm.hasOwnProperty("s") && fm.s != null && fm.hasOwnProperty("a") && fm.a != null) {
                            if (fm.a[1] && fm.a[1].c) {
                                if (paTweak.ui.RaidReporter.cityIds == null) {
                                    paTweak.ui.RaidReporter.cityIds = new Array();
                                }
                                var troops = "";
                                var fortifications = "";
                                var buildings = " ";
                                for (var ii = 0; ii < fm.s.length; ++ii) {
                                    switch (String(fm.s[ii].t)) {
                                        case "15":
                                            if (buildings.indexOf(" CG ") < 0) {
                                                buildings += "CG ";
                                            }
                                            break;
                                        case "16":
                                            if (buildings.indexOf(" TG ") < 0) {
                                                buildings += "TG ";
                                            }
                                            break;
                                        case "17":
                                            if (buildings.indexOf(" ST ") < 0) {
                                                buildings += "ST ";
                                            }
                                            break;
                                        case "18":
                                            if (buildings.indexOf(" WS ") < 0) {
                                                buildings += "WS ";
                                            }
                                            break;
                                        case "19":
                                            if (buildings.indexOf(" SY ") < 0) {
                                                buildings += "SY ";
                                            }
                                            break;
                                        case "36":
                                            if (buildings.indexOf(" MT ") < 0) {
                                                buildings += "MT ";
                                            }
                                            break;
                                        case "37":
                                            if (buildings.indexOf(" TT ") < 0) {
                                                buildings += "TT ";
                                            }
                                            break;
                                        case "38":
                                            if (fortifications.indexOf(" L ") < 0) {
                                                fortifications += "L ";
                                            }
                                            break;
                                        case "39":
                                            if (fortifications.indexOf(" BT ") < 0) {
                                                fortifications += "BT ";
                                            }
                                            break;
                                        case "40":
                                            if (fortifications.indexOf(" GT ") < 0) {
                                                fortifications += "GT ";
                                            }
                                            break;
                                        case "41":
                                            if (fortifications.indexOf(" RT ") < 0) {
                                                fortifications += "RT ";
                                            }
                                            break;
                                        case "42":
                                            if (fortifications.indexOf(" TP ") < 0) {
                                                fortifications += "TP ";
                                            }
                                            break;
                                        case "43":
                                            if (fortifications.indexOf(" PF ") < 0) {
                                                fortifications += "PF ";
                                            }
                                            break;
                                        case "44":
                                            if (fortifications.indexOf(" BR ") < 0) {
                                                fortifications += "BR ";
                                            }
                                            break;
                                        case "45":
                                            if (fortifications.indexOf(" AT ") < 0) {
                                                fortifications += "AT ";
                                            }
                                            break;
                                        case "46":
                                            if (fortifications.indexOf(" CT ") < 0) {
                                                fortifications += "CT ";
                                            }
                                            break;
                                        default:
                                            break;
                                    }
                                }
                                for (var ii = 0; ii < fm.a[1].u.length; ++ii) {
                                    switch (String(fm.a[1].u[ii].t)) {
                                        case "1":
                                            troops += "CG ";
                                            break;
                                        case "2":
                                            troops += "BL ";
                                            break;
                                        case "3":
                                            troops += "RG ";
                                            break;
                                        case "4":
                                            troops += "GD ";
                                            break;
                                        case "5":
                                            troops += "TP ";
                                            break;
                                        case "6":
                                            troops += "ZK ";
                                            break;
                                        case "7":
                                            troops += "MG ";
                                            break;
                                        case "8":
                                            troops += "SC ";
                                            break;
                                        case "9":
                                            troops += "XB ";
                                            break;
                                        case "10":
                                            troops += "PL ";
                                            break;
                                        case "11":
                                            troops += "KN ";
                                            break;
                                        case "12":
                                            troops += "WL ";
                                            break;
                                        case "13":
                                            troops += "RM ";
                                            break;
                                        case "14":
                                            troops += "CT ";
                                            break;
                                        case "15":
                                            troops += "FR ";
                                            break;
                                        case "16":
                                            troops += "SL ";
                                            break;
                                        case "17":
                                            troops += "WG ";
                                            break;
                                        case "19":
                                            troops += "BA ";
                                            break;
                                        default:
                                            break;
                                    }
                                }
                                var tmpStr = formatDate(fm.h.d) + "," + convertIdToCoordinates(fm.a[1].c[0].i) + "," + buildings + "," + fortifications + "," + troops + "," + formatReportId(fm.sid) + "," + fm.a[0].p + "," + fm.a[0].ai + "," + fm.a[1].p + "," + fm.a[1].ai;
                                paTweak.ui.RaidReporter.cityIds[String(fm.a[1].c[0].i)] = tmpStr + "," + ("##" + fm.a[1].c[0].i + "ll##") + "," + ("##" + fm.a[1].c[0].i + "hc##");
                                webfrontend.net.CommandManager.getInstance().sendCommand("GetPublicCityInfo", { id: fm.a[1].c[0].i }, this, gotCityInfo);
                            }
                        }
                        break;
                    }
                }
            }
        }
    });
});