loader.addFinishHandler(function () {

    qx.Class.define("paTweak.ui.ReturnByWindow", {
        type: "singleton",
        extend: qx.ui.window.Window,
        construct: function () {
            this.base(arguments, 'Return raids by');
            this.buildUI();

            // Refresh info every time
            //this.addListener("appear", this.returnRaidsBy, this);
        },
        members: {
            _returnTime: null,
            buildUI: function () {
                var app = qx.core.Init.getApplication();

                this.setLayout(new qx.ui.layout.VBox(2));
                this.set({allowMaximize: false, allowMinimize: false, showMaximize: false, showMinimize: false,
                    showStatusbar: false, showClose: false, contentPadding: 5, useMoveFrame: true, resizable: false});
                this.setWidth(200);
                webfrontend.gui.Util.formatWinClose(this);

                var wcLabel = new qx.ui.basic.Label("Return all raids by:").set({font: "bold"});
                this.add(wcLabel);

                this._returnTime = new paTweak.ui.components.TimePicker("Return time:");
                this.add(this._returnTime);

                var firstRow = new qx.ui.container.Composite();
                firstRow.setLayout(new qx.ui.layout.HBox());
                this.add(firstRow);

                // Apply button
                var applyButton = new qx.ui.form.Button("Apply");
                applyButton.addListener("execute", this.returnRaidsBy, this);
                firstRow.add(applyButton);

                // Close button
                var closeButton = new qx.ui.form.Button("Close");
                closeButton.addListener("execute", this.hide, this);
                firstRow.add(closeButton);
            },
            returnRaidsBy: function () {
                var combatTools = paTweak.CombatTools;
                var returnBy = this._returnTime.getValue().getTime();
                var st = webfrontend.data.ServerTime.getInstance();
                var serverStep = st.getServerStep();
                var gameNow = webfrontend.Util.getCurrentTime().getTime();
                var delta = Math.floor((returnBy - gameNow) / 1000) + 1;
                returnBy = serverStep + delta;
                var currRecurrType = 2;
                var orders = webfrontend.data.City.getInstance().unitOrders;
                for (var i in orders) {
                    if (orders[i].type == paTweak.CombatTools.RAID_ORDER_ID) {
                        webfrontend.net.CommandManager.getInstance().sendCommand("UnitOrderSetRecurringOptions", {cityid: webfrontend.data.City.getInstance().getId(), id: orders[i].id, isDelayed: orders[i].isDelayed, recurringType: currRecurrType, recurringEndStep: (returnBy)}, null, null, null);
                    }
                }
                this.hide();
            }
        }
    });
});