loader.addFinishHandler(function () {

    qx.Class.define("paTweak.ui.components.LeftPanel", {
        extend: qx.ui.container.Composite,
        construct: function (label) {
            this.base(arguments);
            this.buildPanelUI(label);
        },
        members: {
            content: null,
            closeMercToolsBtn: null,
            maxHeight: 207,
            buildPanelUI: function (labelText) {
                this.setLayout(new qx.ui.layout.Canvas());
                this.set({marginTop: 3, marginBottom: 3});

                var background = new qx.ui.basic.Image('http://eaassets-a.akamaihd.net/lougame/cdn/406071/resource/webfrontend/ui/menues/main_menu/bgr_subheader_citinfo_scaler.png');
                background.set({width: 338, scale: true, allowGrowY: true});
                this.add(background, {left: 0, top: 27, bottom: 34});

                background = new qx.ui.basic.Image('http://eaassets-a.akamaihd.net/lougame/cdn/406071/resource/webfrontend/ui/menues/main_menu/bgr_subheader_citinfo_end.png');
                background.set({width: 338, height: 35});
                this.add(background, {left: 0, bottom: 0});

                background = new qx.ui.basic.Image("http://eaassets-a.akamaihd.net/lougame/cdn/406071/resource/webfrontend/ui/menues/main_menu/bgr_subheader_citinfo_wide.png");
                background.set({width: 338, height: 32});
                this.add(background, {left: 0, top: 0});

                var label = new qx.ui.basic.Label(labelText);
                label.set({font: "bold", textColor: "#ffCC82"});
                this.add(label, {left: 13, top: 8});

                this.content = new qx.ui.container.Composite();
                this.content.setLayout(new qx.ui.layout.VBox(5));
                this.content.set({width: 322, marginBottom: 8});
                this.add(this.content, {top: 35, left: 8});

                this.closeImage = new qx.ui.basic.Image("webfrontend/ui/icons/icon_chat_resize_smaller.png");
                this.closeImage.setWidth(16);
                this.closeImage.setHeight(16);
                this.closeImage.setScale(true);
                this.closeImage.setAlignY("middle");
                this.closeMercToolsBtn = new qx.ui.form.Button();
                this.closeMercToolsBtn.set({width: 20, appearance: "button-text-small", toolTipText: "Hide Merc Tools"});
                this.closeMercToolsBtn.addListener("click", this.toggleMercTools, this);
                this.closeMercToolsBtn._add(this.closeImage);
                this.add(this.closeMercToolsBtn, {top: 6, left: 304});

                this.aboutMercToolsBtn = new qx.ui.form.Button("?");
                this.aboutMercToolsBtn.set({appearance: "button-text-small", toolTipText: "About Merc Tools"});
                this.aboutMercToolsBtn.addListener("execute", this.showHelp, this);
                this.add(this.aboutMercToolsBtn, {top: 6, left: 108});

                this.showIncomingAttacksBtn = new qx.ui.form.Button("I");
                this.showIncomingAttacksBtn.set({visibility: "hidden", width: 20, appearance: "button-text-small", toolTipText: "Incoming Attacks Window"});
                this.showIncomingAttacksBtn.addListener("execute", this.showIncomingAttacks, this);
                this.add(this.showIncomingAttacksBtn, {top: 6, left: 126});

                this.showCombatButtonBtn = new qx.ui.form.Button("C");
                this.showCombatButtonBtn.set({visibility: "hidden", width: 20, appearance: "button-text-small", toolTipText: "Combat/PvP Attack Setup Window"});
                this.showCombatButtonBtn.addListener("execute", this.showCombatWindow, this);
                this.add(this.showCombatButtonBtn, {top: 6, left: 146});

                this.showRaidButtonBtn = new qx.ui.form.Button("R");
                this.showRaidButtonBtn.set({visibility: "hidden", width: 20, appearance: "button-text-small", toolTipText: "Raiding Tools Window"});
                this.showRaidButtonBtn.addListener("execute", this.showRaidingWindow, this);
                this.add(this.showRaidButtonBtn, {top: 6, left: 166});

                this.showReportsBtn = new qx.ui.form.Button("S");
                this.showReportsBtn.set({visibility: "hidden", width: 20, appearance: "button-text-small", toolTipText: "Scouting Reports Window"});
                this.showReportsBtn.addListener("execute", this.showReports, this);
                this.add(this.showReportsBtn, {top: 6, left: 186});

                this.showMailingListBtn = new qx.ui.form.Button("M");
                this.showMailingListBtn.set({visibility: "hidden", width: 20, appearance: "button-text-small", toolTipText: "Mailing Lists Window"});
                this.showMailingListBtn.addListener("execute", this.showMailingLists, this);
                this.add(this.showMailingListBtn, {top: 6, left: 206});

                this.showSendCityDataBtn = new qx.ui.form.Button("U");
                this.showSendCityDataBtn.set({visibility: "hidden", width: 20, appearance: "button-text-small", toolTipText: "Upload/Send City Data"});
                this.showSendCityDataBtn.addListener("execute", this.sendCityData, this);
                this.add(this.showSendCityDataBtn, {top: 6, left: 226});

                this.showPalaceItemsBtn = new qx.ui.form.Button("P");
                this.showPalaceItemsBtn.set({visibility: "hidden", width: 20, appearance: "button-text-small", toolTipText: "Palace Items Window"});
                this.showPalaceItemsBtn.addListener("execute", this.showPalaceItems, this);
                this.add(this.showPalaceItemsBtn, {top: 6, left: 246});
            },
            _mg: function () {
                this.closeMercToolsBtn.setVisibility("hidden");
                this.showSendCityDataBtn.setVisibility("visible");
            },
            getContent: function () {
                return this.content;
            },
            toggleMercTools: function () {
                var barButtonsVisibility = "hidden";
                if (!this.content.getVisibility().iCompare("visible")) {
                    barButtonsVisibility = "visible";
                    this.closeImage.setSource("webfrontend/ui/icons/icon_chat_resize.png");
                    this.content.setVisibility("hidden");
                    this.closeMercToolsBtn.setToolTipText("Show Merc Tools");
                    this.setMaxHeight(32);
                }
                else {
                    this.closeImage.setSource("webfrontend/ui/icons/icon_chat_resize_smaller.png");
                    this.content.setVisibility("visible");
                    this.setMaxHeight(this.maxHeight);
                    this.closeMercToolsBtn.setToolTipText("Hide Merc Tools");
                }
                this.showCombatButtonBtn.setVisibility(barButtonsVisibility);
                this.showRaidButtonBtn.setVisibility(barButtonsVisibility);
                this.showIncomingAttacksBtn.setVisibility(barButtonsVisibility);
                this.showReportsBtn.setVisibility(barButtonsVisibility);
                this.showMailingListBtn.setVisibility(barButtonsVisibility);
                this.showSendCityDataBtn.setVisibility(barButtonsVisibility);
                this.showPalaceItemsBtn.setVisibility(barButtonsVisibility);
            },
            updateContent: function (widget, args) {
                this.remove(this.content);
                (widget && args) ? this.addContent(widget, args) : this._mg();
            },
            addContent: function (widget, args) {
                this.content.add(widget, args);
                this.maxHeight = this.getMaxHeight();
            }
        }
    });
});
