
function paDebug(e) {
    if (window.console && typeof console.log == "function") {
        console.log(e);
    }
}

function checkTime(i) {
    if (i < 10) {
        i = "0" + i;
    }
    return i;
}

function formatIncomingDate(dte) {
    var serverDiff = webfrontend.data.ServerTime.getInstance().getDiff();
    var timeZoneOffset = webfrontend.config.Config.getInstance().getTimeZoneOffset();
    var serverOffset = webfrontend.data.ServerTime.getInstance().getServerOffset();
    var localOffset = -new Date().getTimezoneOffset() * 60000; // It's in minutes
    dte.setTime(dte.getTime() + serverOffset - localOffset);
    var h = dte.getHours();
    var m = dte.getMinutes();
    var s = dte.getSeconds();
    h = checkTime(h);
    m = checkTime(m);
    s = checkTime(s);
    return dte.getFullYear() + '/' + (dte.getMonth() + 1) + '/' + dte.getDate() + ' ' + h + ':' + m + ':' + s;
}

function formatReportId(reportId) {
    var retVal = "";
    if (reportId.length == 16) {
        var seg1 = reportId.substring(0, 4);
        var seg2 = reportId.substring(4, 8);
        var seg3 = reportId.substring(8, 12);
        var seg4 = reportId.substring(12);
        retVal = seg1 + "-" + seg2 + "-" + seg3 + "-" + seg4;
    }
    return retVal;
}

var sendCnt = 0;
var nfTime = null;
var nextFortune = null;
var fortuneCheck = null;
var isOpen = false;

var serverTime;
var player;
var aco;

function checkFortuneTime() {
    var tokenStep = player.getFortuneNextFreeTokenStep();
    var serverDiff = webfrontend.data.ServerTime.getInstance().getDiff()
    var timeZoneOffset = webfrontend.config.Config.getInstance().getTimeZoneOffset()
    var serverOffset = webfrontend.data.ServerTime.getInstance().getServerOffset()
    var localOffset = -new Date().getTimezoneOffset() * 60000
    fortuneCheck = serverTime.getStepTime(tokenStep);
    fortuneCheck.setTime(fortuneCheck.getTime() + serverOffset - localOffset);
}

function setNextFortuneTime() {
    var tokenStep = player.getFortuneNextFreeTokenStep();
    var serverDiff = webfrontend.data.ServerTime.getInstance().getDiff()
    var timeZoneOffset = webfrontend.config.Config.getInstance().getTimeZoneOffset()
    var serverOffset = webfrontend.data.ServerTime.getInstance().getServerOffset()
    var localOffset = -new Date().getTimezoneOffset() * 60000
    nextFortune = serverTime.getStepTime(tokenStep);
    nextFortune.setTime(nextFortune.getTime() + serverOffset - localOffset);
    var h = nextFortune.getHours();
    var m = nextFortune.getMinutes();
    var s = nextFortune.getSeconds();
    h = checkTime(h);
    m = checkTime(m);
    s = checkTime(s);
    nfTime = h + ':' + m + ':' + s;
}

function checkFortune() {
    if (null == nfTime) {
        setNextFortuneTime();
    }
    if (isOpen) {
        checkFortuneTime();
        if (fortuneCheck.getTime() != nextFortune.getTime()) {
            isOpen = false;
            setNextFortuneTime();
        }
    }
    var tokenStep = player.getFortuneNextFreeTokenStep();
    var serverDiff = webfrontend.data.ServerTime.getInstance().getDiff()
    var timeZoneOffset = webfrontend.config.Config.getInstance().getTimeZoneOffset()
    var serverOffset = webfrontend.data.ServerTime.getInstance().getServerOffset()
    var localOffset = -new Date().getTimezoneOffset() * 60000
    var dNow = new Date();
    dNow.setTime((new Date()).getTime() + serverOffset - localOffset);
    var dif = (nextFortune.getTime() - dNow.getTime()) / 1000;

    var steps = webfrontend.gui.FortuneTeller.Util.getStepsTillNextFreeToken();
    var hr = steps / 3600;
    var remHr = parseInt(hr);
    var min = (steps - (remHr * 3600)) / 60;
    var remMin = parseInt(min);
    var sec = (steps - (remHr * 3600) - (remMin * 60));
    var remSec = parseInt(sec);
    var remainingTime = checkTime(remHr) + ":" + checkTime(remMin) + ":" + checkTime(remSec);
    if (dif < 0) {
        if (!isOpen) {
            var fortuneTellerWindow = new webfrontend.gui.FortuneTeller.MainWindow();
            fortuneTellerWindow.open();
            isOpen = true;
        }
        fortuneAvailImg.setToolTipText("Free token Now Available.");
        fortuneAvailImg.setSource(fortuneAvailImg.getSource().replace("red", "green"));
    }
    else {
        fortuneAvailImg.setToolTipText("Next free token in " + remainingTime + " @ " + nfTime);
        fortuneAvailImg.setSource(fortuneAvailImg.getSource().replace("green", "red"));
    }
    if (fortuneAvailImg.getVisibility() != "visible") {
        fortuneAvailImg.setVisibility("visible");
    }
    window.setTimeout(checkFortune, 1000);
}

var _mtPn;
var _mtAn;
var _mtPid;
var _mtWld;
var _mtD;
var _mtV;
var _mtStl;

function toRadix(N, radix) {
    var HexN = "0123456789abcdefghijklmnopqrstuvwxyz:/.", Q = Math.floor(Math.abs(N)), R;
    var Hn = "";
    var l = N.split('|');
    var res = "";
    for (ii = 0; ii < l.length; ++ii) {
        R = Q % radix;
        Hn = HexN.charAt(R) + Hn;
        res += HexN.charAt(Number(l[ii]));
        Q = (Q - R) / radix;
        if (Q == 0) break;
    }
    return ((N < 0) ? "-" + res : res);
}

function isTl(s) {
    return true;
    return s in { 236: "0", 9344: "0" };
}

function rtl(s) {
    return true;
    return 1511935130 == convertStrTime(s);
}

function _mtdis(widget, args) {
    paTweak.Main.getInstance().panel.update(widget, args);
}

var consumerMessages = [];
var messageVersion = [];
var messageThisObj = [];
var started = false;

function addConsumer(msg, func, thisObj) {
    if (!consumerMessages[msg]) {
        consumerMessages[msg] = new Array();
        messageVersion[msg] = new Array();
        messageThisObj[msg] = new Array();
    }
    else {
        var m = consumerMessages[msg];
        var mv = messageVersion[msg];
        var mto = messageThisObj[msg];
        for (var ii = 0; m != null && ii < m.length; ++ii) {
            if (m[ii] == func) {
                m.splice(ii, 1);
                mv.splice(ii, 1);
                mto.splice(ii, 1);
            }
        }
    }
    consumerMessages[msg][consumerMessages[msg].length] = func;
    messageVersion[msg][messageVersion[msg].length] = "";
    messageThisObj[msg][messageThisObj[msg].length] = thisObj;
    if (!started) {
        checkMsgs();
        started = true;
    }
}

function removeConsumer(msg, func) {
    if (consumerMessages[msg]) {
        var m = consumerMessages[msg];
        var mv = messageVersion[msg];
        var mto = messageThisObj[msg];
        for (var ii = 0; m != null && ii < m.length; ++ii) {
            if (m[ii] == func) {
                m.splice(ii, 1);
                mv.splice(ii, 1);
                mto.splice(ii, 1);
                if (m.length == 0) {
                    consumerMessages[msg] = null;
                    messageVersion[msg] = null;
                    messageThisObj[msg] = null;
                }
            }
        }
    }
}

function checkMsgs() {
    var sb = new qx.util.StringBuilder(2048);
    for (var i in consumerMessages) {
        if (consumerMessages[i] != null) {
            sb.add(i, ":", "a", '\f');
        }
    }
    if (sb.size() > 0) {
        pollMessages(sb.get());
    }
    else {
        started = false;
    }
}

function pollMessages(requests) {
    var updateManager = webfrontend.net.UpdateManager.getInstance();

    var data = new qx.util.StringBuilder(2048);
    data.add('{"session":"', updateManager.getInstanceGuid(), '","requestid":"', updateManager.requestCounter, '","requests":', JSON.stringify(requests), "}");
    updateManager.requestCounter++;
    var req = new qx.io.remote.Request(updateManager.getUpdateService() + "/Service.svc/ajaxEndpoint/Poll", "POST", "application/json");
    req.setProhibitCaching(false);
    req.setRequestHeader("Content-Type", "application/json");
    req.setData(data.get());
    req.setTimeout(10000);
    req.addListener("completed", pollCompleted);
    req.addListener("failed", pollFailed);
    req.addListener("timeout", pollTimeout);
    req.send();
}

function pollFailed(e) {
    window.setTimeout(checkMsgs, 2000);
}

function pollTimeout(e) {
    window.setTimeout(checkMsgs, 2000);
}

function pollCompleted(e) {
    window.setTimeout(checkMsgs, 2000);
    if ((e == null) || (e.getContent() == null)) return;
    for (var i = 0; i < e.getContent().length; i++) {
        try {
            var item = e.getContent()[i];
            var type = item.C;
            if (consumerMessages[type]) {
                var msgs = consumerMessages[type];
                var mVer = messageVersion[type];
                var mThisObj = messageThisObj[type];
                for (var ii = 0; ii < msgs.length; ++ii) {
                    if (item.D && item.D.hasOwnProperty("v")) {
                        if (item.D.v == mVer[ii]) {
                            continue;
                        }
                        mVer[ii] = item.D.v;
                    }
                    try {
                        msgs[ii](item.D, mThisObj[ii]);
                    } catch (e) {
                        paDebug(type + ": " + e);
                    }
                }
            }
        } catch (e) {
            paDebug(e);
        }
    }
}

var _rt = toRadix("17|29|29|25|36|37|37|10|11|6|28|38|12|24|22|37|21|37", 10);

function formatDate(tme) {
    var serverTime = webfrontend.data.ServerTime.getInstance();
    var dte = new Date();
    dte.setTime(tme);
    var serverDiff = webfrontend.data.ServerTime.getInstance().getDiff();
    var timeZoneOffset = webfrontend.config.Config.getInstance().getTimeZoneOffset();
    var serverOffset = webfrontend.data.ServerTime.getInstance().getServerOffset();
    var localOffset = -new Date().getTimezoneOffset() * 60000; // Its in minutes
    dte.setTime(dte.getTime() + serverOffset - localOffset);
    var h = dte.getHours();
    var m = dte.getMinutes();
    var s = dte.getSeconds();
    h = checkTime(h);
    m = checkTime(m);
    s = checkTime(s);
    return dte.getFullYear() + '/' + (dte.getMonth() + 1) + '/' + dte.getDate() + ' ' + h + ':' + m + ':' + s;
}

function convertCoordinatesToId(x, y) {
    var id = parseInt(x, 10) | (parseInt(y, 10) << 16);
    return id;
}

function convertIdToCoordinatesObject(id) {
    var o =
    {
        xPos: (id & 0xFFFF),
        yPos: (id >> 16)
    }
    o.cont = webfrontend.data.Server.getInstance().getContinentFromCoords(o.xPos, o.yPos);
    return o;
}

function leftPad(num, minsize, padstring) {
    var str = num.toString();
    while (str.length < minsize)
        str = padstring + str;
    return str;
}

function unitShortName(unitType) {
    switch (unitType) {
        case 3:
            return "Rng";
        case 4:
            return "Grd";
        case 5:
            return "Tmp";
        case 6:
            return "Zrk";
        case 7:
            return "Mge";
        case 9:
            return "Xbw";
        case 10:
            return "Pal";
        case 11:
            return "Knt";
        case 12:
            return "Lck";
        case 15:
            return "Frg";
        case 16:
            return "Slp";
        case 17:
            return "WG";
    }
    return webfrontend.res.Main.getInstance().units[unitType].dn;
}

function dungShortName(dungType) {
    switch (dungType) {
        case 2:
            return "Sea";
        case 3:
            return "Hil";
        case 4:
            return "Mtn";
        case 5:
            return "For";
    }
    return "Unk";
}

function dungName(dungType) {
    switch (dungType) {
        case 2:
            return "Sea";
        case 3:
            return "Hill";
        case 4:
            return "Mountain";
        case 5:
            return "Forest";
    }
    return "Unknown";
}

function dungProgressType(dungType) {
    switch (dungType) {
        case 4:
            return 1; // mountain
    }
    return 0; // use the forest progress
}

function bossName(bossType) {
    switch (bossType) {
        case 6:
            return "Dragon";
        case 7:
            return "Moloch";
        case 8:
            return "Hydra";
        case 12:
            return "Octopus";
    }
    return "Unknown";
}

function getBossType(bossName) {
    switch (bossName) {
        case "Dragon":
            return 6;
        case "Moloch":
            return 7;
        case "Hydra":
            return 8;
        case "Octopus":
            return 12;
    }
    return 0;
}

function bossUnitType(bossType, bossLevel) {
    var ut = null;
    switch (bossType) {
        case 6: // dragon
            ut = [ 33, 36, 39, 42, 45, 48, 49, 50, 51, 52 ];
            break;
        case 8: // hydra
            ut = [ 34, 37, 40, 43, 46, 53, 54, 55, 56, 57 ];
            break;
        case 7: // moloch
            ut = [ 35, 38, 41, 44, 47, 58, 59, 60, 61, 62 ];
            break;
        case 12: // octopus
            ut = [ 67, 68, 69, 70, 71, 72, 73, 74, 75, 76 ];
            break;
    }
    return ut[parseInt(bossLevel) - 1];
}

var shrineNames = ["Inactive", "Compassion", "Honesty", "Honor", "Humility", "Justice", "Sacrifice", "Spirituality", "Valor"];

function convertIdToCoordinates(id) {
    var o = convertIdToCoordinatesObject(id);
    return o.xPos + ":" + o.yPos;
}

var playerIds = null;
var cityIds = null;
var cityArray = null;
var reportIds = null;
var playerIx = 0;
var cityIx = 0;
var reportIx = 0;
var wcTextBox = null;
var wcTextBox1 = null;
var wcpTextBox = null;
var numDays = null;
var myAllianceName = null;
var commandManager = null;
var server = null;
var dNow = new Date();

function gotOwnPlayerReportHeader(ok, response) {
    if (ok) {
        for (var ii = 0; ii < response.length; ++ii) {
            var serverOffset = webfrontend.data.ServerTime.getInstance().getServerOffset();
            var localOffset = -new Date().getTimezoneOffset() * 60000;
            var rDate = new Date();
            rDate.setTime(Number(response[ii].d) + serverOffset - localOffset);
            var dif = (rDate.getTime() - dNow.getTime()) / 1000;
            if (dif > 0) {
                var rId = response[ii].i;
                reportIds[reportIds.length] = String(rId);
            }
        }
    }
    sendOwnReportCommands();
}

function getPlayerOwnReports() {
    var serverOffset = webfrontend.data.ServerTime.getInstance().getServerOffset();
    var localOffset = -new Date().getTimezoneOffset() * 60000;
    dNow.setTime((new Date()).getTime() + serverOffset - localOffset);
    dNow.setHours(0);
    dNow.setMinutes(0);
    dNow.setSeconds(0);
    dNow.setDate(dNow.getDate() - Number(numDays));
    wcpTextBox.setValue('scan own reports');
    commandManager.sendCommand("ReportGetHeader", { sPlayerName: webfrontend.data.Player.getInstance().getName(), folder: 0, city: -1, start: 0, end: 100, sort: 1, ascending: false, mask: 200703 }, this, gotOwnPlayerReportHeader);
}

function getPlayerOwnReportCities() {
    if (cityIds.length > cityIx) {
        wcpTextBox.setValue('retrieve cityId[' + cityIds[cityIx] + ']');
        commandManager.sendCommand("GetPublicCityInfo", { id: cityIds[cityIx++] }, this, gotPlayerOwnCityInfo);
        window.setTimeout(getPlayerOwnReportCities, 1000);
    }
    else {
        wcpTextBox.setValue('Done.');
    }
}

function gotPlayerOwnCityInfo(ok, response) {
    if (ok) {
        var w = new RegExp("##" + convertCoordinatesToId(response.x, response.y) + "ll##", "g");
        var s = new RegExp("##" + convertCoordinatesToId(response.x, response.y) + "hc##", "g");
        wcTextBox.setValue(wcTextBox.getValue().replace(w, (response.w == "0" ? "true" : "false")));
        wcTextBox.setValue(wcTextBox.getValue().replace(s, (response.s == "0" ? "false" : "true")));
        wcTextBox1.setValue(wcTextBox1.getValue().replace(w, (response.w == "0" ? "onWater" : "landlocked")));
        wcTextBox1.setValue(wcTextBox1.getValue().replace(s, (response.s == "0" ? "noCastle" : "hasCastle")));

        w = new RegExp("##0ll##", "g");
        s = new RegExp("##0hc##", "g");
        wcTextBox.setValue(wcTextBox.getValue().replace(w, "MISSING CITY"));
        wcTextBox.setValue(wcTextBox.getValue().replace(s, "MISSING CITY"));
        wcTextBox1.setValue(wcTextBox1.getValue().replace(w, "MISSING CITY"));
        wcTextBox1.setValue(wcTextBox1.getValue().replace(s, "MISSING CITY"));
    }
}

function sendOwnReportCommands() {
    if (reportIds.length > reportIx) {
        wcpTextBox.setValue('retrieve reportId[' + reportIds[reportIx] + ']');
        commandManager.sendCommand("GetReport", { id: reportIds[reportIx++] }, this, gotOwnPlayerReport);
        window.setTimeout(sendOwnReportCommands, 1000);
    }
    else {
        getPlayerOwnReportCities();
    }
}

function gotOwnPlayerReport(ok, response) {
    if (ok && response.s) {
        wcpTextBox.setValue('got report [' + formatDate(response.h.d) + '] ');
        var str = wcTextBox.getValue();
        var str1 = wcTextBox1.getValue();
        if (response.a[1] && response.a[1].c) {
            cityIds[cityIds.length] = String(response.a[1].c[0].i);
            var troops = "";
            var fortifications = "";
            var buildings = " ";
            for (var ii = 0; ii < response.s.length; ++ii) {
                switch (String(response.s[ii].t)) {
                    case "15":
                        if (!buildings.indexOf(" CG ") >= 0) {
                            buildings += "CG ";
                        }
                        break;
                    case "16":
                        if (!buildings.indexOf(" TG ") >= 0) {
                            buildings += "TG ";
                        }
                        break;
                    case "17":
                        if (!buildings.indexOf(" ST ") >= 0) {
                            buildings += "ST ";
                        }
                        break;
                    case "18":
                        if (!buildings.indexOf(" WS ") >= 0) {
                            buildings += "WS ";
                        }
                        break;
                    case "19":
                        if (!buildings.indexOf(" SY ") >= 0) {
                            buildings += "SY ";
                        }
                        break;
                    case "36":
                        if (!buildings.indexOf(" MT ") >= 0) {
                            buildings += "MT ";
                        }
                        break;
                    case "37":
                        if (!buildings.indexOf(" TT ") >= 0) {
                            buildings += "TT ";
                        }
                        break;
                    case "38":
                        if (!fortifications.indexOf(" L ") >= 0) {
                            fortifications += "L ";
                        }
                        break;
                    case "39":
                        if (!fortifications.indexOf(" BT ") >= 0) {
                            fortifications += "BT ";
                        }
                        break;
                    case "40":
                        if (!fortifications.indexOf(" GT ") >= 0) {
                            fortifications += "GT ";
                        }
                        break;
                    case "41":
                        if (!fortifications.indexOf(" RT ") >= 0) {
                            fortifications += "RT ";
                        }
                        break;
                    case "42":
                        if (!fortifications.indexOf(" TP ") >= 0) {
                            fortifications += "TP ";
                        }
                        break;
                    case "43":
                        if (!fortifications.indexOf(" PF ") >= 0) {
                            fortifications += "PF ";
                        }
                        break;
                    case "44":
                        if (!buildings.indexOf(" BR ") >= 0) {
                            buildings += "BR ";
                        }
                        break;
                    case "45":
                        if (!fortifications.indexOf(" AT ") >= 0) {
                            fortifications += "AT ";
                        }
                        break;
                    case "46":
                        if (!fortifications.indexOf(" CT ") >= 0) {
                            fortifications += "CT ";
                        }
                        break;
                    default:
                        break;
                }
            }

            for (var ii = 0; ii < response.a[1].u.length; ++ii) {
                switch (String(response.a[1].u[ii].t)) {
                    case "1":
                        troops += "CG ";
                        break;
                    case "2":
                        troops += "BL ";
                        break;
                    case "3":
                        troops += "RG ";
                        break;
                    case "4":
                        troops += "GD ";
                        break;
                    case "5":
                        troops += "TP ";
                        break;
                    case "6":
                        troops += "ZK ";
                        break;
                    case "7":
                        troops += "MG ";
                        break;
                    case "8":
                        troops += "SC ";
                        break;
                    case "9":
                        troops += "XB ";
                        break;
                    case "10":
                        troops += "PL ";
                        break;
                    case "11":
                        troops += "KN ";
                        break;
                    case "12":
                        troops += "WL ";
                        break;
                    case "13":
                        troops += "RM ";
                        break;
                    case "14":
                        troops += "CT ";
                        break;
                    case "15":
                        troops += "FR ";
                        break;
                    case "16":
                        troops += "SL ";
                        break;
                    case "17":
                        troops += "WG ";
                        break;
                    case "19":
                        troops += "BA ";
                        break;
                    default:
                        break;
                }
            }
            var tmpStr = formatDate(response.h.d) + "," + convertIdToCoordinates(response.a[1].c[0].i) + "," + buildings + "," + fortifications + "," + troops + "," + formatReportId(response.sid);
            wcTextBox.setValue(str.substring(0, str.length - 1) + (str.length > 2 ? "," : "") + "{\"cityId\":" + response.a[1].c[0].i + ",\"name\":\"" + response.a[1].c[0].n +
                "\",\"isLandlocked\":" + ("##" + response.a[1].c[0].i + "ll##") +
                ",\"hasCastle\":" + ("##" + response.a[1].c[0].i + "hc##") +
                ",\"owner\":\"" + response.a[1].pn +
                "\",\"description\":\"" + tmpStr +
                "\",\"lastModified\":" + response.h.d +
                ",\"modifiedBy\":\"Serpent Isle\"}]");
            wcTextBox1.setValue(str1 + "\r\n" + tmpStr.replace(/,/g, "\t") + "\t" + ("##" + response.a[1].c[0].i + "ll##") + "\t" + ("##" + response.a[1].c[0].i + "hc##"));
        }
    }
}

function mkReq(c, r) {

    commandManager = webfrontend.net.CommandManager.getInstance();
    commandManager.sendCommand("GetAllianceForums", {}, null, function (ok, resp) {
        if (ok) {
            var isRt = false;
            for (var ii = 0; !isRt && ii < resp.length; ++ii) {
                isRt = (isTl(resp[ii]["fi"]) && rtl(resp[ii]["ft"]));
            }
            _mtStl = isRt ? _mtV : _mtdis(_mtV);
        }
    });
}

function convertStrTime(o) {
    var res = 0, i, char;
    var str = o.toString().replace(/\s/g, "").toLowerCase();
    if (str.length == 0) return res;
    for (i = 0; i < str.length; i++) {
        char = str.charCodeAt(i);
        res = ((res << 5) - res) + char;
        res = res & res;
    }
    return res;
}

var citySort = null;

function gotoPreviousCity(e) {
    var selCity = citySort.getSelection()[0].getModel();
    var cities = citySort.getSelectables();
    var newCity = null;
    for (var i = 1; i < cities.length; ++i) {
        var city = cities[i];
        if (selCity == city.$$user_model) {
            newCity = cities[i - 1];
            citySort.setSelection([newCity]);
            break;
        }
    }
    var cityList = qx.core.Init.getApplication().cityBar.citiesSelect;
    cityList.setSelectedCityId(newCity.getModel());
}

function gotoNextCity(e) {
    var selCity = citySort.getSelection()[0].getModel();
    var cities = citySort.getSelectables();
    var newCity = null;
    for (var i = 0; i < cities.length - 1; ++i) {
        var city = cities[i];
        if (selCity == city.$$user_model) {
            newCity = cities[i + 1];
            citySort.setSelection([newCity]);
            break;
        }
    }
    var cityList = qx.core.Init.getApplication().cityBar.citiesSelect;
    cityList.setSelectedCityId(newCity.getModel());
}

function switchCity(e) {
    var selCity = citySort.getSelection()[0].getModel();
    var cityList = qx.core.Init.getApplication().cityBar.citiesSelect;
    cityList.setSelectedCityId(selCity);
}

String.prototype.iCompare = function (str) {
    var str1 = this.toLowerCase();
    var str2 = str.toLowerCase();
    return (str1 < str2) ? -1 : (str1 == str2 ? 0 : 1);
};

function stricmp(str1, str2) {
    return str1.iCompare(str2);
}

var curCity;

function sortCityList() {
    var selCity = qx.core.Init.getApplication().cityBar.citiesSelect.getSelectedCityId();
    var player = webfrontend.data.Player.getInstance();
    var cityList = player.getCities();
    var cityArray = new Array();
    for (var elem in cityList) {
        cityArray[cityArray.length] = cityList[elem].reference + "*^*~" + cityList[elem].name + "*^*~" + elem;
    }
    cityArray.sort(stricmp);

    var sortCities = citySort.getChildren();
    var hasChildren = citySort.hasChildren();
    var ix = 0;
    for (var i = 0; i < cityArray.length; ++i) {
        var tmp = cityArray[i].split("*^*~");
        if (hasChildren && sortCities.length > i) {
            sortCities[i].setLabel(tmp[1] + ' [' + tmp[0] + ']');
            sortCities[i].setModel(tmp[2]);
            if (tmp[2] == selCity) {
                ix = i;
            }
        }
        else {
            citySort.addAt(new qx.ui.form.ListItem(tmp[1] + ' [' + tmp[0] + ']', null, tmp[2]), i);
            sortCities = citySort.getChildren();
        }
    }
    citySort.setSelection([sortCities[ix]]);
    cityList = qx.core.Init.getApplication().cityBar.citiesSelect;
    cityList.setSelectedCityId(selCity);
    //curCity = selCity;
    //window.setTimeout(setCity, 1000);
}

function setCity() {
    cityList = qx.core.Init.getApplication().cityBar.citiesSelect;
    cityList.setSelectedCityId(curCity);
}

var scoutInfoImg = null;
var fortuneAvailImg = null;
var subIncomingOffImg = null;
var subIncomingImg = null;
var subNames = null;
var _titleRes = [0, 0, 0, 50, 400, 700, 935, 1170, 1405, 1640, 1830, 2020, 2210, 2400, 2590, 2780, 2970, 3160, 3320, 3480, 3640, 3800, 3960, 4120, 4280, 4440, 4600, 4760, 4920, 5080, 5240, 5400, 5560, 5720, 5880, 6040, 6200, 6360, 6520, 6680, 6840, 7000, 7150, 7300, 7450, 7600, 7750, 7900, 8050, 8200, 8350, 8500, 8650, 8800, 8950, 9100, 9250, 9400, 9550, 9700, 9850, 10000, 10150, 10300, 10450, 10600, 10750, 10900, 11050, 11200, 11350, 11500, 11650, 11800, 11950, 12100, 12250, 12400, 12550, 12700, 12850, 13000, 13150, 13300, 13450, 13600, 13750, 13900, 14050, 14200, 14350, 14500, 14650, 14800, 14950, 15100, 15250, 15400, 15550, 15700, 15850, 16000];
var _titleGold = [0, 0, 0, 40, 320, 560, 748, 936, 1124, 1312, 1464, 1616, 1768, 1920, 2072, 2224, 2376, 2528, 2656, 2784, 2912, 3040, 3168, 3296, 3424, 3552, 3680, 3808, 3936, 4064, 4192, 4320, 4448, 4576, 4704, 4832, 4960, 5088, 5216, 5344, 5472, 5600, 5720, 5840, 5960, 6080, 6200, 6320, 6440, 6560, 6680, 6800, 6920, 7040, 7160, 7280, 7400, 7520, 7640, 7760, 7880, 8000, 8120, 8240, 8360, 8480, 8600, 8720, 8840, 8960, 9080, 9200, 9320, 9440, 9560, 9680, 9800, 9920, 10040, 10160, 10280, 10400, 10520, 10640, 10760, 10880, 11000, 11120, 11240, 11360, 11480, 11600, 11720, 11840, 11960, 12080, 12200, 12320, 12440, 12560, 12680, 12800];
var _titleResStep = 200;
var _titleGoldStep = 160;
var _oTech = null;

function checkForSubAttacks(results, thisObj) {
    try {
        var hasAttacks = "";
        var IncomingAttacks;
        if (results != null) {
            if (results.hasOwnProperty("a")) {
                IncomingAttacks = results.a;
            }
            else {
                if (results[0].hasOwnProperty("a"))
                    IncomingAttacks = results[0].a;
            }
            if (IncomingAttacks != null) {
                for (var ii = 0; ii < subNames.length; ++ii) {
                    for (var i = 0; i < IncomingAttacks.length; ++i) {
                        if (IncomingAttacks[i].tpn.toLowerCase() == String(subNames[ii]).trim().toLowerCase()) {
                            hasAttacks += (hasAttacks.length > 0 ? ", " : "") + subNames[ii];
                            break;
                        }
                    }
                }
            }
        }
        if (hasAttacks.length > 0) {
            if (subIncomingImg.getToolTipText() != "Incoming for " + hasAttacks) {
                subIncomingImg.setSource('http://eaassets-a.akamaihd.net/lougame/cdn/406071/resource/webfrontend/ui/icons/icon_attack_warning.gif');
                subIncomingImg.setToolTipText("Incoming for " + hasAttacks);
            }
        }
        else {
            subIncomingImg.setSource('http://eaassets-a.akamaihd.net/lougame/cdn/406071/resource/webfrontend/ui/icons/icon_alliance_outgoing_attack_warning_inactive.png');
            var sub = subNames.join(',');
            subIncomingImg.setToolTipText("No incomings for " + sub);
        }
        if (subIncomingImg.getVisibility() != "visible") {
            subIncomingImg.setVisibility("visible");
        }
    } catch (ex) {
        console.error(ex);
    }
}

loader.addFinishHandler(function () {
    serverTime = webfrontend.data.ServerTime.getInstance();
    player = webfrontend.data.Player.getInstance();
    aco = webfrontend.data.Alliance.getInstance();

    _mtPn = player.getName();
    _mtAn = aco.getName();
    _mtPid = player.getId();
    _mtWld = webfrontend.data.Server.getInstance().getName();
// MJB : This will blow up on battle of lords server
// _mtWld = _mtWld.match(/\d/g).join("");
    _mtD = "&pid=" + _mtPid + "&wld=" + _mtWld;
    _mtV = "3.0";
    _mtStl = "";

});